================================================================================ 
= Alpha change log						 
================================================================================ 
 
Fixes and improvements of 7.x versions of Alpha carried out by Vince Darley
with much help from Tom Fetherston, Johan Linde, Jon Guyer and suggestions
from the Alpha-D mailing list.  Alpha is shareware; please register with
the author using the register button in the about box.

Many, many of the fixes and changes below were provided by the Alpha user
community.  If there's something you don't like about Alpha, feel free to
try to change/fix it.

Many known bugs are listed in the "Bug Reports and Debugging" readme.  
These will all (hopefully) be fixed in Alpha 8.0.  There is no current 
release date for Alpha 8.0, and there's no point in asking.  If you'd
like to suggest new features etc for Alpha 8.0, the Alpha-D mailing
list is the correct place to suggest them.

================================================================================ 
= 7.2.1b11 released					last update: 7/8/1999 {4:18:53 pm}
================================================================================ 
¥ doc projects can auto-update Copyright years now
¥ more robust recentFilesMenu, and file::getModeForFile etc
¥ added fantastic ISOTime package from Frederic (in CorePackages)
  (modified ISOTime package to cope with Tcl8isms and AlphaTk)
¥ made bunch of small changes to SystemCode and CorePackages for
  easier use with Tcl 8.  Renamed hook::list to hook::information,
  cache::read to cache::readContents cache::open to cache::fopen,
  dialog::variable to dialog::value_for_variable
¥ minor doc-projects fix, when changing name of a project, menu is now
  rebuilt.
¥ latex.tcl magic char fix
¥ better support in Tcl mode for Itcl, and various TclPro features.
¥ updated Alpha keywords section of Tcl mode.
¥ fixed nasty superSearch bug
¥ updated 'tomac' in shellMode so it works properly with Tcl8, and
  other problematic procs.
================================================================================ 
= 7.2.1b10 released					last update: 7/8/1999 {4:18:53 pm}
================================================================================ 
¥ more robust auto loading etc
¥ installer now has option to overwrite even newer files
¥ removed global {} variable
¥ closeHook more robust
¥ getVarValue fix
¥ smartPaste fix
¥ DocProjects fix
¥ Much improved help, readme etc (Johan).  The new manual is so much better
  than the old one.  I recommend everyone read it!  Especially those who
  are new to Alpha and those who have used Alpha a long time, but never 
  really caught on to all the changes in Alpha 7.0, 7.1, 7.2.
¥ recentFiles fix from Dominique
¥ some support for next Textures release: set 'useNewerTexturesInterface' 
  flag to activate this support.
¥ regexp space fix for Tcl8
¥ unusual recent files bug fix (two files, same tail, but first file doesn't
  actually exist).
¥ tcltk::evaluate fix
================================================================================ 
= 7.2.1b9 released					last update: 19/7/1999 {10:32:15 pm}
================================================================================ 
¥ warning when Alpha encounters an unusual core bug, usually manifested
  as a weird startup error, and the creation of a folder 'Alpha-v'.  
  Hopefully worked around it as much as is possible.  Can't be fixed till 
  Alpha8.  (If you use 'file copy' 'file rename' 'file delete' instead of
  moveFile, copyFile etc, your code will automatically avoid the bug when
  Alpha8 is released).
¥ minor matlab mode modernisation
¥ removed extra msg from supersearch
¥ fixed internet updates menu sometimes empty
¥ AElig fix in HTML mode
¥ removed all references to my old email/web pages from source/help files
¥ startup a little more robust.
================================================================================ 
= 7.2.1b8 released					last update: 8/7/1999 {1:47:57 am}
================================================================================ 
¥ hopefully fixed emacs menu dim bug (solution: use [set win::Active], not
  [winNames] if in procs called from an activateHook).
¥ fixed marking msg for modes without marking
¥ fixed Diff problem
¥ fixed supersearch: variety of issues, including browse mode support for 
  multi-line finds.
¥ odd line ending problems removed.
================================================================================ 
= 7.2.1b7 released					last update: 4/7/1999 {7:42:47 pm}
================================================================================ 
¥ recentFiles cosmetic fix for Tcl8
¥ supersearch improvements (thanks Dominique).
¥ added minPos, pos::math and pos::compare to "Alpha Commands"
¥ improved developerUtilities marking
¥ supersearch can now do wrap searches
¥ ring::nth added to templates.tcl
¥ more Diff mode improvements
================================================================================ 
= 7.2.1b5,b6 released					last update: 3/7/1999 {2:01:38 pm}
================================================================================ 
¥ minor recentFilesMenu ordering fix.  Infinite loop under
  odd circumstances removed.
¥ more robust auto-indexing, and changes to better support read-only
  directories, Tcl8 etc.
¥ Dominique's improvements to vsp/ring::clear for better completions
  tutorials -- Thanks!
¥ added helper 'dialog::editOneOfMany' used by Java mode, and User
  details.
¥ improvements to Diff mode.
¥ added diskModifiedHook which is called when Alpha learns that an
  open window has been modified on disk.  Default behaviour is just to
  put a message in the status bar.
¥ improved twiddle and twiddleWords (thanks!)
================================================================================ 
= 7.2.1b4 released					last update: 14/6/99 {6:41:22 pm}
================================================================================ 
¥ fixes for recentFilesMenu, install and auto_mkindex, and files in 
  wrong place.
================================================================================ 
= 7.2.1b3 released					last update: 8/6/1999 {7:29:38 pm}
================================================================================ 
¥ recentFilesMenu improved, and copies over old prefs.
¥ better handling of configuration options in first line of file
  (like: (tabsize:4)).
¥ better error checking in auto_mkindex which warns the user of bad
  problems.
¥ Frontier menu update which I forgot to put in 7.2 (thanks Johan)
¥ latexMenu fixes from Dominique
¥ recentFilesMenu improvements for duplicate files, plus prefs moved
  to separate prefs dialog in packages menu.
¥ fix to quote::Find, and addition of quote::Glob, plus fix of several
  places which used quote::Find instead of quote::Regfind
¥ more flexible 'gotoMatch' in Brws mode.  Different windows can
  register their own gotoMatch handler (e.g. Mailboxes).
¥ small latexMenu addition
¥ Java mode compilation improvements for package hierarchies
¥ reworked 'glob' with extra arguments etc (see coreFixes.tcl), so
  Alpha works with folders containing glob-sensitive characters []{}+*?\
  Mode/package authors should go through their code and correct bugs
  involving glob.  Almost any use of glob is suspect. See
  coreFixes.tcl for details of new glob syntax.
================================================================================ 
= 7.2 released						last update: 24/5/1999 {6:29:13 pm}
================================================================================ 
¥ M2 mode icon, plus other icons cleaned up (thanks Andreas)
¥ new pascal mode (thanks Johan)
¥ latex theorem labels better (thans Juan)
¥ recentFiles menu has a flag for alphabetical vs most recent
  ordering, and a key-binding to edit the most recent file (all recent
  file preferences are in the Config->Preferences->Files page).
  Thanks Juan.
¥ ftpMenu fix (thanks Tom)
¥ fillParagraph works on box-comments too
¥ fillParagraph position remembering works well for comments (box/para)
¥ somewhat experimental TeX code so when Alpha is asked to edit a
  temporary file, it tries to edit the correct file instead.
¥ fixes to Frontier code from Johan.
¥ cancelled save-as bug fix.
¥ fillParagraph position remembering code doesn't use global vars any more
¥ addRemoveDollars generalised and moved to textManip.tcl, renamed to
  'togglePrefix', which takes one argument: the prefix.
¥ internet updates fix for ftp sites.
¥ minor fix to date::isOlder for Alpha-dev release, plus better error msgs
¥ hook fix
¥ bibtex/tex menu interaction fix
¥ better Alpha-dev release compatibility
¥ aeparse, latex theorem, smart quotes, ... fixes.
¥ HTML and related mode updates
¥ small dialog, Docprojects fixes.
================================================================================ 
= 7.2fc11 released						last update: 21/4/99 {2:52:56 pm}
================================================================================ 
¥ minor latex menu fix (extra space)
¥ indentation and elec expansion fixes for Alpha-dev
¥ user details pref saving bug-fix with multiple identities
¥ indentation only messes with spaces/tabs at the beginning of the line.
¥ aebuild fix from alpha-d list
¥ more progress msgs at startup
¥ new cmd 'alpha::flag' which simplifies some feature declarations (see
  indentation.tcl for examples).
¥ minor fixes to appPaths, packages, textFill
¥ addition of unstuffSig as a helper (can set to Mindvision expander)
¥ some www/ftp improvements
¥ indentation fix (minor)
================================================================================ 
= 7.2fc10 released						last update: 16/4/1999 {9:46:01 pm}
================================================================================ 
¥ minor changes to a few Help files
¥ minor fix to latexUtilities
¥ formatEntry jumps to next non-whitespace char afterwards, not necessarily
  the next entry (bibtex mode)
¥ supersearch can be turned off again.  The on/off ability of shift-cmd-F 
  is a purely temporary thing which is ignored when you quit & restart
¥ fat version of Gnu Diff (many thanks to Rob Managan)
¥ minor preference and TeX menu changes
¥ preferences which aren't explicitly added to a given var/flagPrefs() 
  array entry are now added to the 'Miscellaneous Packages' item in the
  Config->Packages menu, rather than to 'Miscellaneous' in the 
  Config->Preferences menu.  This is equivalent to adding them to the 
  (Packages) array entry.
¥ new Applevents packages and help from Jon.
¥ added help to emacs pref items
¥ indentation pays better attention to indentUsingSpacesOnly feature
¥ aebuild improvement
¥ tclMode, remoteTclShell improved
¥ Extending Alpha additions
¥ new icons: please rebuild your desktop (hold down opt-cmd when the 
  finder starts up).
================================================================================ 
= 7.2fc9 released						last update: 12/4/1999 {5:38:56 pm}
================================================================================ 
¥ install .tcl won't rebuild unless some file is actually installed
  (if files are too new or equal, then no rebuild happens -- please
  test this new feature).
¥ improved handling of -tabsize by 'new' (thanks Tom)
¥ file modified on disk messages added to alphaHooks.tcl
¥ better copyRing, smartPaste
¥ removed too much recursion from cMode indentation
¥ fixed (I think) supersearch conflict with deleteComments via addition of
  procedure 'performSearch'.  This behaves a bit like 'search' but is for use
  from Tcl code which wishes to make correct use of further procs like
  replaceAll etc.  Also fixed deleteComments bug.
¥ supersearch turned into a feature so it can be activated/deactivated 
  correctly.
================================================================================ 
= 7.2fc8 released						last update: 8/4/99 {1:31:31 am}
================================================================================ 
¥ intelCutPaste moved to copyRing and renamed, copyRing fixes
¥ great supersearch improvements for 'inselection' searches, plus some
  other fixes (thanks Dominique)
¥ tabsize fixed in brws mode under some circumstances
¥ Diff::rerun fixed
¥ 'enterSearchString' clears the 'inselection' flag in supersearch, unless
  the entered string is inside the 'inselection' range.
¥ renamed package prefs menu to 'packages' to reflect its contents better.
¥ longstanding ftpMenu bug fixed (thanks Tom)
¥ elecExpansions, completions minor fixes
¥ by default tex filesets don't include eps files (there's a fileset flag
  to store the preference).
¥ tcl::continueComment fix 
¥ bib indexing improvements (thanks Juan)
¥ bugs with []{} in file/dir names fixed.
¥ preferences rearrangement, and minor bug fix.
¥ great AMS-LaTeX environment improvements for tex mode (thanks)
================================================================================ 
= 7.2fc7 released						last update: 22/3/1999 {2:04:22 pm}
================================================================================ 
¥ placed prompt vars in Gui preference pane
¥ in-selection fix for supersearch, other supersearch improvements
¥ java mode uses better indentation as for C,C++ below
¥ bibConvert handles yet another format.
¥ proc 'dialog::_reqWidth' added to dialogs.tcl to calculate text 
  width for buttons, menus, checkboxes etc.
¥ fixes to supersearch, copyRing (thanks)
¥ evaluate moved to tcl menu (you can make the Tcl menu global if you want
  evaluate to be there always as cmd-L, or you can add a binding to your
  prefs.tcl --- most users said they prefered evaluate out of the edit 
  menu).
================================================================================ 
= 7.2fc6 released						last update: 19/3/99 {9:15:06 pm}
================================================================================ 
¥ copyRing menu enabling/disabling moved from alphaHooks
¥ superSearch fixes
¥ developerUtilities improvements
¥ minor install fix for repeat installs
¥ Bug Reports and Debugging and Extending Alpha readmes updated.
¥ minor fill paragraph improvement (still no comment-box filling).
¥ "Tcl mailing list" help file renamed and filled with more useful info.
¥ fixes to superSearch (thanks Dominique)
¥ prompts vars moved to globals
¥ better indentation in C,C++ modes for those who like left braces on a line
  of their own.
¥ mark::getRange fix (thanks Frederic)
================================================================================ 
= 7.2fc5 released						last update: 17/3/1999 {7:30:26 pm}
================================================================================ 
¥ Minor install changes (cosmetic).
¥ mode-search-paths fix
¥ better comment filling of text using cmd-I
¥ install fix
¥ text::isInComment fix and numerous similar regexp/regsub potential problems
¥ dialog view-filename adjusted for better viewing of long names - thanks!
¥ InSt small icon (in next non-patch release) - thanks!
¥ some supersearch \r\n\t fixes (new pref 'quoteFunnyChars')
¥ bibConvert handles yet another inspec format
¥ calc improvements
================================================================================ 
= 7.2fc4 released						last update: 16/3/1999 {6:34:08 pm}
================================================================================ 
¥ Emacs menu enabling/disabling moved from alphaHooks to emacs package
¥ toolserver shell fix
¥ python icon fix (in next non-patch release)
¥ install 'no changes' no longer rebuilds anything
¥ saveAs and win::Modified fix for modification date read a little early
¥ ability to uninstall multiple modes/menus/features
================================================================================ 
= 7.2fc3 released
================================================================================ 
¥ Perl mode fixes (thanks)
¥ coreFixes and alphaHooks fixes for file-modified stuff
================================================================================ 
= 7.2fc2 released
================================================================================ 
¥ fillParagraph fixes
¥ keeps track of when a file has changed on disk, and adjust save/revert
  flags as appropriate.  Fixed a bunch of old bugs related to duplicate 
  windows in alphaHooks.tcl, and added 'file changed on disk.  are you 
  sure you want to save?' functionality.  Lots of changes to 
  alphaHooks.tcl and coreFixes.tcl.
================================================================================ 
= 7.2fc1 released
================================================================================ 
¥ Minor changes to 'early' prefs and packages: things which must be set or
  initialised early in the startup sequence.  More robust technique now.
¥ Version of AlphaTcl detached from Alpha
¥ System installer will give option of saving installation log before quit.
¥ Readme displayed after changes to either Alpha or AlphaTcl (in the long
  run we may want a different readme for these two cases).
¥ fixed (un)commentBox bugs
¥ latex fileset relative paths bug fix for Alpha dev release.
¥ minor startup changes.
================================================================================ 
= 7.2b4 released
================================================================================ 
¥ various minor fixes.  Really fixed dead-key workaround.
================================================================================ 
= 7.2b3 released
================================================================================ 
¥ sortLines improved, and takes new flag '-d' to remove duplicates
¥ simplified various comment/uncomment box/para procedures.
¥ copyRing fixes/improvements
¥ filling of text inside comments!  Works for some modes at least: C, C++, 
  Tcl, Java.  Not sure which others.  Fill also now respects the selection
  limits given and won't meddle with text outside those limits.
¥ Dominique's workaround for dead-key problem, plus other fixes
¥ added latex mode flag to not take over entire numeric keypad
¥ Ovid bib format added to bibConvert package.
¥ fixed namespace {} in toolboxRefMenu
¥ added call to reset electricMenu when bindings are changed.
¥ improvements to electricMenu insertions, and smartPaste
¥ install.tcl and fileManipulation.tcl fixes for Alpha dev. release.
================================================================================ 
= 7.2b2 released
================================================================================ 
¥ fixed ancient bug in changeMode related to traces
¥ double-space and fill and shift improvements to textFill/Manip.tcl
¥ tabsize back to 8 in browser window, but converted tabs to spaces in 
  text prior to entry in window.
================================================================================ 
= 7.2b1 released
================================================================================ 
¥ added 'Recurse in folder...' fileset (appears in search dialogs)
¥ fixes and improvements to tclMode and remoteTclShell
¥ bug fix to alphaCommands.tcl (templates in Shel mode etc)
¥ latex mode handles pdf
¥ minor elec template improvements
¥ Alpha's version will stay at 7.2, with the Tcl code's version being 
  updated by smaller patch releases (basically the application hasn't
  changed for years).
¥ various minor improvements to java, C, toolboxRef, textManip (from Chuck)
¥ fixed search dialog vanishing fileset problem
¥ improvements to supersearch, and better help text
¥ better C++, Tcl indentation.  Other Tcl improvements
¥ new proc 'text::indentBy' used by smartPaste, shiftLeft and shiftRight
¥ shiftLeft/Right now use 'indentationAmount'. This means the global 
  variable/pref 'shiftChar' is no longer used.  
¥ singlePage renamed to defaultSize (changes to win, menus, internationalMenus)
¥ minor change to install.tcl to make it easy to update the core
¥ better cMode indentation (thank you!)
================================================================================ 
= 7.1.7 and 7.1.8 released
================================================================================ 
¥ scanning for help text improved slightly
¥ 'extending alpha' additions
¥ supersearch improvements
¥ fixed variety of unfortunate problems recently introduced
¥ fix silly bug just introduced
¥ on startup if the package indices are rebuilt, so are the tcl indices.  
  This means you can now install a package (at least simple packages) by
  simply moving them into any of Alpha's standard Tcl folders, and then
  quitting and restarting Alpha.  This is NOT the recommended way of
  installing them, since it bypasses any special installation procedure
  a package may have.  Also if the file you move replaces an old one,
  Alpha will not notice and you may well get startup errors.
¥ additional keyboard support, and removal of appleevent at startup 
  problem.  Fix of 'new -info' bug.
================================================================================ 
= 7.1.6 released
================================================================================ 
¥ backup related fixes and improvements from Johan
¥ auto-setting of keyboard from Johan, at least for recent MacOS.  An array 
  needs filling in for keyboard names.
¥ even more fixes from Johan.
¥ additions to 'new' --- all flags that setWinInfo takes can now be used, 
  also args '-text' to set the text, or a useful new flag '-info'
  which takes the text as the next arg, and automatically sets the
  window to a read-only shell window, and scrolls to the top after
  inserting the given text.  Useful for all those 'info' windows Alpha
  uses!  Numerous examples throughout SystemCode/Modes
¥ more space allowed in yesno and optionmenu dialogs
¥ all sorts of minor fixes.
¥ print header problem always had page number problem fixed
¥ various Diff, mark related fixes (thanks Frederic)
¥ simplified sendUrl to use icURL.  You can over-ride it using 
  smarterSource if you want some behaviour other than standard
  Internet Config linking.
¥ more help text in prefs defined in globals.tcl
¥ simplified some regsub's in SystemCode.  Learnt a new thing: regsub always
  copies the string into the given variable, even if there were no matches.
¥ small bug fix to cache.tcl
¥ betterTemplates start up fix
¥ better shift left/right procs in textManip (thanks Mark)
  'shiftChar' is now a global preference.  You can add a mode specific 
  override easily for any given mode.
¥ added new pref type 'funnyChars' which uses quote::(Un)display 
  before/after placing in prefs dialog for easier editing.  
  'shiftChar' is an example.
¥ minor improvements to bibtex mode, dialogs, menusAndKeys
¥ smartPaste simplified (no longer a need for a preference)
================================================================================ 
= 7.1.5 released
================================================================================ 
¥ <shift><click> on the file name in titlebar menu also does a Show In
  Finder, rather than copying the path as it used to.
¥ improved help in some global dialogs.  See 'Extending Alpha' for how
  to write preference help so that it is useful both now (Alpha 7.1) and
  in the future (Alpha 8.0) when it will be used automatically in balloon
  help.  See globals.tcl for examples of how these are written.
  FEEL FREE TO CONTRIBUTE NEW HELP TEXT FOR POORLY EXPLAINED ITEMS!
¥ fixed Tcl 8 problem in errors.tcl, improved efficiency of code for Tcl 8
  in numerous places all over SystemCode.
¥ version number is now a 'sub-version' rather than a 'pN' patch version.
¥ fewer things in the core clobber errorInfo, which is nicer for debugging
  (you can switch to the Tcl shell and do 'set errorInfo' and expect 
  something useful, rather than something to do with the process of 
  switching to the shell!).  The way to avoid clobbering errorInfo is to
  avoid using 'catch' unless it is really necessary.  Note that 'catch'
  is actually quite slow too, since it has to set the error state.
¥ Readme is up to date with new menus and urls, similar fixes in a few
  places in Tcl code.
¥ Updated HTML mode manual
¥ minor latex mode/filesets improvements
¥ improved C,C++ indentation
¥ supersearch fix
¥ saveasHook improvement
¥ small rearrangements of coreFixes, alphaBits
¥ There's now both an Alpha package and an AlphaTcl package.  In the 
  future the version of 'Alpha' will change relatively infrequently, but that
  of AlphaTcl more frequently.  Alpha is the application, AlphaTcl the set 
  of files contained in the Tcl:SystemCode directory.  If you currently 
  use 'alpha::package require/exists/... Alpha' you should probably change
  that to 'AlphaTcl' in the future if you want to check for 7.1.5 or 
  whatever.
¥ various minor improvements to SystemCode files, recentFiles and 
  filesetsMenu, especially regarding aliases and Tcl 8.
¥ fixes to ftpMenu from Johan
================================================================================ 
= 7.1p4 released
================================================================================ 
¥ Jon and Mark Nagata added this nice feature: Title Bar clicking has been
  modified in accordance with discussion here a few weeks ago. Mark Nagata
  and I worked things around so that clicking the topmost item (file name) in
  the popup path copies the full path to the Clipboard. "Fetched" files get
  their URL copied to the Clipboard.

  Selecting lower items in the popup (folders in the path), causes the old
  behavior of opening an SFGetBox with that folder current. <shift><click> on
  a folder item opens the appropriate folder in the Finder (this was always
  there).
¥ no longer automatically remove leading, trailing and double 
  menu-separators automatically.  Package writers are assumed not to
  make such errors. (there was a conflict with the win-menu).
¥ internationalMenus fix for new menu setup
¥ change... changed to changeMode...
¥ better file::showInFinder from Juan
¥ fix to procs::reformatEnclosing
¥ addition of icon resource to Alpha, and BNDL, FREFs for installer files
  their type is 'InSt'.   developerUtils package updated accordingly.  
  You'll need to rebuild your desktop to see the new icon on such files.
¥ minor codewarrior menu fix, and prev error addition
¥ prevMatch added to browser mode
¥ beginning of support in ftpMenu for http too (the 'fetched' and other
  variables take a fifth element the 'type' = ftp, http etc).
¥ added couple of mark related procs to Alpha commands.  Simplifies Diff 
  mode.  
¥ procs::findEnclosing is now happy with procs which don't start a line.
¥ some documentation in 'Extending Alpha' for how to embed preference help
  in your package files.  This will be used for balloon help in a future
  Alpha release.  It is currently used when you press 'help' in a dialog.
¥ changed version to p4 (!)
¥ fixed v. rare problem in alphaHooks with lsearch
¥ TeX fixes (thanks!)
================================================================================ 
= 7.1p3 released
================================================================================ 
¥ dialog::text, dialog::yesno are nicer, and dialog::alert has been 
  added.  In particular, dialog::yesno has configurable buttons.
¥ better startup error messages (using new procs)
¥ addition of UniversalHeaders pref to C++ mode, and opt-Q key-binding
  to open one of the headers v. quickly.
¥ improvements to fileManipulation.tcl and prompts.tcl
¥ minor emacs fix
¥ lots of menu rearrangments after recent discussion on Alpha-D
  (feedback on new arrangement much appreciated)
¥ required a bunch of code changes.  In particular the docProjects package
  needed updating for the new structure.
¥ fixed little bug in dialog::text (manifested in special keys... dialog)
¥ internationalMenu pkg updates for new menus
¥ few more menu changes
¥ dialog::password new proc in core Tcl
¥ minor improvement to C++ mode indentation
¥ installer fix for newer files from Jon
¥ some ae improvements from Jon
================================================================================ 
= 7.1p2 released
================================================================================ 
¥ fixed unBind, print problems
¥ tiny latex mode fix (missing '.')
¥ fix for startup after previous problematic startup (rare problem)
¥ fix in file::getModeForFile in case of aliases
¥ better startup error messages
¥ minor changes to tclLog and shellMode
¥ latex mode has a 'customising' section in the manual.  Not much 
  there yet.
¥ improved java mode
¥ latest HTML etc modes from Johan.
¥ auto_mkindex now includes procs not at the beginning of a line (Tcl 
  8.0.3 or newer do this too)
================================================================================ 
= 7.1p1 released
================================================================================ 
¥ updated urls, links etc to Pete's and Vince's new web/archive sites.
¥ proper bibtex mode included
¥ bug fixes from Johan to search, clickUtils, browserMode
¥ Jon's new jumpPrev/Next func
¥ Juan's 'quickSearch'
¥ minor TeX improvements
¥ AlphaBits.tcl works for 7.1 and 8.0 dev version (not publically available)
¥ autoContinueComment is now a feature so you can turn it on/off
¥ horiz scroll bar is on by default
¥ java marking and menu improvements/fixes
¥ various indentation/beginning of file fixes in generic code
  (could cause infinite loops in java mode, for instance)
¥ added feature 'indentUsingSpacesOnly' for Rowland.  It just needs 
  activating for whichever mode requires it.
¥ fixed slow return in latex mode for Rowland
¥ replaced previous fix with new commentsArentSpecialWhenIndenting feature
  which can be used in any mode.
================================================================================ 
= 7.1 released
================================================================================ 
¥ updated links and urls for Pete's new sites
¥ register application included with distribution 
¥ fixed couple of bugs in electric menu and docprojects
¥ fixed perl electric left/right problems
¥ fixed C++ indent empty line
¥ fixed smarterSource startup problems
¥ various latex fixes and all other stuff reported on Alpha-D
¥ updated Johan's link to new docs
¥ updated various modes, esp frontier.
¥ added camlMode
¥ prevFunc etc improvements
¥ Perl completions fixed; dbl-clicking not as nice as before.
¥ win.tcl minor fix
¥ new icons added (caml + some tcl related ones)
¥ latex improvements
¥ bib to refer
¥ eudoraMenu updates
¥ shellMode fix
¥ BNDL bits set
================================================================================ 
= 7.1fc5 released
================================================================================ 
¥ new win.tcl (thanks Chuck)
¥ recent files fix
¥ parseFuncs calling mechanism improved
¥ file extension mappings for each mode are stored without cr's etc.
¥ few documentation improvements
¥ removed pagestyle-empty etc from latex sectioning
¥ more latex documentation improvements
¥ electric Colon is a feature like the other electric things.  Modes 
  should remove any mode var 'electricColon'.
¥ sped up the global return/brace/tab type routines by avoiding calls 
  to 'unknown'.  Side effect of this required some changes elsewhere.  
  One benefit is that things should work with tcl8 unchanged now.  
  Other side-effects: <mode>::<proc> is now required for the usual
  electricX, carriageReturn etc.  The backwards compatible 
  <mode><proc> have been removed (I don't think any modes use the old 
  versions any more).  Changing mode will be slower the first time, 
  since Alpha now forces mode specific procs to be loaded.  Various
  generic procs are called '::XX' now so that everything is will work
  ok with tcl 7 or 8.  Need to think about how to make changing mode
  the first time faster.  These changes may have introduced some new
  bugs: however they'll be easy to fix.
  The trick of electric/indent procs using 'error' to force use of the
  generic procedure no longer works.  Call the generic procedure 
  directly instead (it's quicker that way too!).
¥ text::genericIndent deprecated.  Call '::indentLine' instead.
  (backwards compatibility proc is included)
¥ changing mode faster again, but relies upon new behaviour for correct
  functionality: on startup each mode must ensure its 'mode::MarkFile',
  'mode::electricX' type procs are loaded in.  Currently, I believe all
  modes already do that.  However it wasn't previously a requirement;
  now it is.  The list of procs which must be loaded are stored in the
  'mode::procs' variable.  The reason I don't force the attempted 
  loading of each of these procs is that that takes a long time if the
  procs don't exist.
¥ document projects help file included.
¥ hopefully updated all links to Pete's new ftp and web sites for 
  Alpha.
¥ eudora menu 'global' option added
================================================================================ 
= 7.1fc4 released
================================================================================ 
¥ eudora menu problem fixed
¥ fileset menu problem with aliases fixed.
¥ improvement to auto_load
¥ TeX mode can use CMacTeX's pdfTeX
¥ Java mode func marking works again, smart paste too.
¥ updated to Internet Config 2.0
¥ Java improvements
¥ mv,cp fixes from Johan
¥ fix for ':' and cmd-double-click problem.
¥ indentationTypes moved to globals.tcl, couple of other moves.
¥ slovenian and croatian keyboards supported
¥ improved C++ and Java indentation.
¥ fixed filesets flags menu (core problem)
¥ improvements to emacs pkg.
================================================================================ 
= 7.1fc3 released
================================================================================ 
¥ Mercutio 1.5.2
¥ 'Top Window Folder' renamed to 'Top Window's Folder'
¥ Java improvements
¥ Documentation improvements.
¥ new HTML mode and manual.
¥ fixed problem with dialog::handleSet when used from multi-page 
  dialogs which contain sublists of items (WWW dialog problem).
¥ fixed help for 'get_directory' to show 'Cancel' = error, not empty string.
  Fixed couple of places in dialogs.tcl which relied on empty string 
  behaviour.
================================================================================ 
= 7.1fc2 released ('+' release was due to incorrect initial release)
================================================================================ 
¥ numerous fixes from Johan -- many thanks as ever.
¥ two replacement icons (IE,..)
¥ updated HTML and related modes and manual
¥ minor C++, Java improvements
¥ increased Alpha's prefered memory allocation.
¥ updated to Mercutio 1.5.1
¥ file::revert renamed to file::revertThese to fix file menu conflict
¥ updated Alpha Manual, Quick Start from Johan.
¥ menu::buildHierarchy improved to work with glob style *.{a,b} 
  patterns.
¥ bug fix to 'menu::flagProc' when used for mode/pkg vars (array entries)
================================================================================ 
= 7.1fc1 released
================================================================================ 
¥ fileset menu minor improvements/fixes
¥ my modified version of tkDiff works more or less now (requires 
  scriptRunner and tkdiffControl packages).  Probably only useful for 
  high-end macs, since Tk is slow on MacOS.
¥ some Java mode improvements
¥ improvements to Diff, Java, Perl and Gnuplot modes
¥ procUtils fix, install improvement.
¥ emacs added to list of default packages.
¥ escapeSmartStuff fix for end of file.
¥ Extending Alpha improvements (Tom and Vince)
================================================================================ 
= 7.1b10 released (probably last beta release)
================================================================================ 
¥ Diff mode extended so can hopefully use tkDiff as a graphical Diff 
  utility external to Alpha (provided you have Tk installed)
¥ twiddle fix
¥ bunch of fixes from Johan
¥ Jon's new code (ae, error etc)
¥ latex Accents fix.
¥ first-time users are asked if they want standard features activated.
¥ dialog::yesno improvements
================================================================================ 
= 7.1b9 released
================================================================================ 
¥ various fixes (thanks Tom, Johan)
¥ TeX, Bib completion problems fixed.
¥ 'forwardDeleteUntil' procedure bound to shift-ctrl-Backspace
  (nice feature from VI: useful for deleting to the end of the 
  sentence etc.)
¥ features can now be turned off for particular modes.
¥ can add '(tabsize:4)' to _first_ line of a file to force a 
  particular tab-size.
¥ new Frontier menu
¥ Tcl mode and TeX mode fixes
¥ more \n file problem fixes (not sure I understand this,...!)
¥ new win.tcl (thanks!)
¥ new showVarValue
================================================================================ 
= 7.1b8 released
================================================================================ 
¥ release problem fixed
¥ printing hopefully fixed
================================================================================ 
= 7.1b7 released
================================================================================ 
¥ some menus updated to use init/activate/deactivate scripts.
¥ scripts for menus as for features: syntax of 'alpha::menu' changed
  to allow extra arguments.  However, complete backwards compatibility
  exists for all cases in which the menu name is an icon (begins 
  with '¥'), which is all current cases to the best of my knowledge.
  See extending Alpha document for new syntax (closer to 
  alpha::feature than the old one).  The new syntax is a little more
  verbose than the old one but helps in that (a) it is clearer what is
  going on, and (b) it's more flexible.  
¥ Shell, bibConvert, showVarValue improvements.
¥ file volumes works now (thanks Jon!)
¥ supersearch replace all in single-file/selection etc much quicker
  (does it all in one go rather than searching item by item)
¥ completion::fromList fixed
¥ various other problems in TeX, Bib,... modes.  thanks for bug reports
¥ IBM file problem fixed.
¥ TeX env indentation fixed.
¥ Changed some 'loading' to 'Loading' so all look same at startup.
¥ status::prompt improvement
¥ C++ mode indentation improved again.
¥ Multiple identities in Docprojects package.
¥ Jon's new ae code (and error.tcl etc)
¥ 'Extending Alpha' document improved somewhat.
¥ Shell fix to carriage-return (thanks johan)
¥ Some improvements to completion code, and fix for TeX Ref completion 
  problem.  Note reference completion only works properly with the
  elecCompletions package installed.
¥ New Perl mode (Tom) (+ new icon)
¥ BibConvert extensions (Jon)
¥ Improvements to superSearch package (esp. 'replace all' code)
¥ Couple new 'quote::' procedures which are useful for dialogs.
¥ Variety of bug fixes.
¥ Brown camel rsrc for Perl mode.
¥ codewarrior menu fix.
================================================================================ 
= 7.1b6 released
================================================================================ 
¥ duplicate window problem fixed.
¥ app::runScript new core procedure which is used by latex and diff 
  modes.
¥ new emacs pkg actually included this time.
¥ all of HTML mode included.
¥ couple of fixes to latex, menus, ...
¥ better backwards compatibility with Alpha 7.0
¥ alpha::mode line can contain a desired version number for 
  menus/features.  Each item is a list {name ?on-by-default? 
  ?desired-version?}.  Feature lists are remembered and updated
  automatically for new versions of your mode.
¥ improved developer utilities (hopefully avoid the recent HTML mode 
  problem).
¥ tryElseDump replaced by try which has been extended a bit.
================================================================================ 
= 7.1b5 released
================================================================================ 
¥ new HTML, JScr modes
¥ better emacs pkg
¥ prompt::getAKey fix, jumping to Tcl procs via cmdDblClick fixed.
¥ 'editMark' now returns 0 if it succeeded, 1 if it failed to find 
  the mark in the given file.
¥ updated Modula2 mode.
¥ fillRegion problem fixed (sorry), and some minor improvements and 
  fixes to TeX and TeX completions.
================================================================================ 
= 7.1b4 released
================================================================================ 
¥ can startup with 'shift' to not load prefs (broke in previous 
  release)
¥ latexFilesets with non-existent files (because you deleted them) no
  longer result in an infinite loop.
¥ 'case ...:' statements indented correctly for C,C++ modes.
¥ better documentation for some new stuff in "Extending Alpha" help 
  file.
¥ fixed Diff problem I introduced recently.
¥ other stuff in b3/b4: some Shell improvements, Diff improvements (Jon)
  LaTeX fixes, some dialog bugs and improvements (Johan), better menu
  disabling (Andreas),...
¥ remote-tcl-shell works again (updated for Jon's aeparse pkg)
================================================================================ 
= 7.1b3 released
================================================================================ 
¥ fixed long-standing pref dialog problem, and related new pref dialog 
  problems: hitting any button except ok/cancel causes Alpha to forget
  changes to other variables: e.g. using Set... or Help makes Alpha
  forget the checkbox/edittext/optionmenu selections you may have
  just made.  Unfortunately not too easy to fix efficiently.
¥ numerous niggling bugs fixed (everything reported on Alpha-D, to
  the best of my knowledge)
¥ better escapeSmartStuff for latex (thanks!)
¥ new Perl mode from Tom
¥ all sorts of other contributions.
================================================================================ 
= 7.1b2 released
================================================================================ 
¥ menu init script recognised and used (on/off scripts still to come)
¥ Jon's new aevt code, try code, ...
¥ working HTML modes.
================================================================================ 
= 7.1b1 released
================================================================================ 
¥ new menu-bindings for mode/global prefs.
¥ Alpha 68k in release again.
¥ some package-downloads bugs
¥ the list of menus in the alpha::mode declaration line is now a list
  of menus and features by default associated with the mode.  For 
  instance you should now add 'electricTab' etc. to that list in place
  of the mode variable 'newPref f electricTab...' of Alpha 7.0
¥ codeWarriorMenu and thinkMenu bugs fixed
¥ 'electricTab' is now a feature, not a mode-preference.  This is 
  good, because it means that turning electricTab on and off on either
  a global or mode-specific basis is handled by Alpha's core.  A mode
  now has to do nothing to support electric tabs.
¥ Also electricReturn, electricBraces, electricSemicolon are now 
  features.  This means the corresponding mode-preferences are now 
  _obsolete_.  They should be removed.
¥ Global selections are now removed from the mode-specific dialogs.
¥ useful new proc 'tryElseDump' used internally a lot now.  If, for example,
  activating a new package fails, the error is caught and, if you
  have the tcl shell open (cmd-Y), the error is dumped into the shell.
¥ made changeMode quite a bit faster (using new package mechanism)
¥ big changes to whole package mechanism.  Now extensions behave more 
  like menus: you can turn them on and off either globally or on a 
  per-mode basis.  The package and alpha-downloads menus have been
  combined, and the 'MenusÉ' selections are now 'Menus And FeaturesÉ'.
  New command 'alpha::feature' which basically replaces the old 
  'alpha::extension' (although that is still supported).  Also there's
  been one minor change (backwards compatible) to 'alpha::menu'.
  The one probable incompatibility is any code which modifies the
  'modeMenus' array.  This is now ignored.  The code has a different
  mechanism for attaching menus to modes (which should happen 
  automatically in all standard cases).
¥ reorganised clickUtils and appPaths
¥ prompt::statusLineComplete can use 'delete' as well as left-arrow to 
  backup, although Alpha's limitations mean 'delete' isn't quite as 
  nice (Try opt-Q in Tcl or Bib mode for an example).
¥ put all file:: procs together in fileManipulation.tcl
¥ small improvements to modes.tcl, menus.tcl
¥ Alpha zaps your Cache when Alpha's core version changes.
¥ latex mode improvements
¥ file::getModeForFile cleverer checking for 'install' on first line.
¥ bibtexMode fixes (thanks)
¥ install.tcl fixes from Jonathan Guyer
¥ rewrote text::genericIndent to avoid crashes due to searching 
  backwards for a complex regexp.  Mostly occured in Java mode.
¥ new proc 'text::inBlockComment' which will check in mode dependent
  way if you're in a '/*  */' type comment (where the actual symbols
  depend upon the mode).  If your mode doesn't use asymmetric comments
  like this then the proc always returns an error.  Use 'catch' if
  necessary.
¥ help dialogs work for modes too
¥ added 'programmer' to list of default fonts.
¥ more help for TeX mode and for Alpha's globals
¥ supersearch package implements find/replace in selection.
¥ two bibtex/bibconvert bugs fixed (thanks)
¥ include Alpha 68k in distribution.
¥ bunch more fixes/improvements from Johan.
¥ renamed bind to Bind and menu to Menu for future compatibility
  (but left in procs so old versions still work).  Its completely
  backwards compatible provided any menu you create uses just 'menu'
  for itself and its submenus or just 'Menu' for itself and its 
  submenus.  Mixing (e.g. Menu -n Blah {item1 item2 {menu -n submenu})
  will not work.  Obviously you should just rename everything to the
  upper-case version.  These are the last two of Alpha's commands which
  conflict with Tcl/Tk (as of version Tcl 8.1 at least), which will 
  make any future transition easier.
================================================================================ 
= 7.0p4-5 released
================================================================================ 
¥ bibConvert handles another inspec format
¥ latex mode can work with new CMacTeX 3.0 xdvi/ghostview components 
  without any changes.
¥ new HTML, Frontier modes
¥ for some reason not all fixes were included in previous distributions
  hopefully that's fixed now.
¥ multi-page help dialogs
¥ improvements to "Extending Alpha" document.  Thanks Tom.
¥ more bug fixes from Johan
¥ commentLine/insertPrefix improvements (many thanks)
¥ rename load to evaluate for future compatibility
¥ removed mod2completions.tcl for the moment
¥ special keys dialog bug fix
¥ (distribution problem so quick release)
================================================================================ 
= 7.0p3 released
================================================================================ 
¥ improved package-index-scanning and newPref gathering
¥ some documentation improvements
¥ bunch of bug fixes (from Johan amongst others)
¥ better package descriptions, more robust startup, better error logging
¥ improved bibToHtml available
¥ hook::callAll now returns the number of registered procs which 
  didn't return normally (i.e. signalled an error)
¥ 'better templates' package significantly faster.
¥ Help feature in standard preference dialogs (not completely finished yet)
================================================================================ 
= 7.0p2 28-1-98
================================================================================ 
¥ paraStart fix (fillParagraph could crash Alpha due to nasty recursion)
  Thanks for very detailed bug report.
¥ Alpha will now check what's in Modes/Menus/Packages at startup and 
  rebuild if it seems something has changed (avoids AlphaLite->Alpha 
  upgrade problem, and most problems which would arise if users 
  manually install packages).  Power-users can hold down option to
  avoid the rebuild.
¥ better C, C++, Tcl, TeX, Bib modes
¥ new 'prompts' core package.
¥ opt-Q is new binding for a mode-dependent quick-find (Tcl, Bib modes)
¥ Perl mode fixed to work properly with Alpha 7.0 (previously it was a 
  bit of a hack which had some problems!)
¥ elec::Wrap minor improvement/fix
¥ minor fix and some improvements to indentation.tcl
¥ very nice new feature.  During the package-indexing process, Alpha
  scans comments which precede 'newPref' statements, and stores them
  in its prefhelp index.  Now when you do 'Describe Mode', Alpha 
  displays by each item what it is used for.  Of course a lot of
  modes aren't very well commented at the moment...
================================================================================ 
= 7.0p1 14-1-98
================================================================================ 
¥ saveasHook fix
¥ improved filesetsMenu, recentFiles, TeX mode
¥ year wrap-around bug in checking alpha-downloads dates fixed
¥ .tcl subscript bug in alpha-downloads fixes
¥ better checking for auto-decompressed downloads; hopefully avoids
  double-decompression, and simplifies netscape/IE problems.
¥ -*- Mode: XX -*- handled. (previously just -*-XX-*-)
¥ dialogs.tcl changes to handle preference-changed procedures which
  are composed of multiple parts.
¥ indentation.tcl fixes to avoid search error in non-whitespace
  searches which hit the end of the file.
¥ added sort paragraphs
¥ significant improvements to bib, tex modes
================================================================================ 
= 7.0 released
================================================================================ 
¥ changes to indentation.tcl and cMode.tcl and startup picture.
¥ added 'saveUnmodified' which saves a file but keeps the old 
  modification date.
¥ changes to elec::Wrap to synchronise with TeX mode's wrapObject
¥ added 'file writable' and 'file size' checks to query web for package list.
¥ inserted templates indent correctly irrespective of tab size 
  (really works now!)
¥ procPatching uses saveUnmodified to avoid problems with updating 
  Alpha's code in the future.
¥ TeX smart paste works
¥ Mercutio 1.5 final
¥ latexSizes improved.
¥ getOpts more flexible
¥ improved bringToFront, revert, TeX smart paste, 
¥ Del key works on all keyboards again.
¥ added aevt code to core, plus Jon's fixes. Make sure you remove 
  'Packages:aevt.tcl' if you have it.
¥ moved some code to 'CorePackages', just to make things a bit more 
  modular.  It's for code which the core needs, but is sufficiently 
  separated from the messy, interlinked SystemCode stuff that it 
  makes sense to keep it separate.  (Ideally everything in systemcode
  should be organised even more and almost everything will end up in
  CorePackages).  Makes maintaining and improving things easier...
================================================================================ 
= 7.0final (?) released
================================================================================ 
¥ fix to win.tcl
¥ added packages prefs page (add to it using alpha::addToPreferencePage)
¥ couple of other minor changes (various packages updated...)
================================================================================ 
= 7.0fc4 released
================================================================================ 
¥ more improvements to hook.tcl
¥ package::findAllExtensions fix (minor)
¥ fixed patch-level back to ""
¥ version in get-info is in sync again.
¥ setFontTabs fixed to not dirty window.
¥ added '.' to quote::Regfind list
¥ can use netscape etc for updating site listings.  It fails 
  initially, but then you are told to wait till the listing is 
  complete and then select a new menu-item.
¥ split fileUtils into winUtils and fileUtils.
¥ minor changes to indentation.tcl
¥ Mercutio MDEF 1.5b2 (contains important fixes)
¥ recentFiles, docProjects, newDocument improvements/fixes from Andreas, Jon.
================================================================================ 
= 7.0fc3 released
================================================================================ 
¥ very cool menu dimming from Andreas
¥ HTML carriage-return problem fixed
¥ TeX fill paragraph small fix
¥ another completion tutorial fix
¥ Tcl var completion better
¥ better menu enabling/disabling
¥ better TeX completions tutorial
¥ modula 2 mode now available
¥ improved replaceInFileset
¥ internal change so '[win::Current]' or '[win::CurrentTail]' are much more 
  efficient than '[lindex [winNames ?-f?] 0]' (or [car [winNames ?-f?]]
¥ better menu dimming, a few internal changes to hook.tcl
¥ winModes renamed to win::Modes (although it shouldn't really be used
  outside of the core code), use 'new -m MODE' instead.
¥ Mercutio MDEF 1.3.5b1 - fixes two potentially crashing bugs.
================================================================================ 
= 7.0fc2 released
================================================================================ 
¥ 'save' dimmed as appropriate
¥ variety of internal changes for better Tcl 8 compatibility
(I think the Tcl code will work unchanged now with either Tcl7.4 or Tcl8.0)
¥ better startup error reporting
¥ some improved documentation
¥ filesetsMenu minor improvements
¥ latexSizes better
¥ inserted templates indent correctly for any tabsize, by noting the 
  indentationAmount pref (both basic and V'sA templates)
¥ various completion tutorial improvements from Tom Fetherston
¥ some latex/bib improvements/fixes
¥ internationalMenus pkg fixes (thanks Frederic)
================================================================================ 
= 7.0fc1p1 and p2 released 
================================================================================ 
¥ TeX improvements
¥ 'new' fix to bug introduced in fc1 release.
¥ listAllBindings and listGlobalBindings
¥ describe mode gives help text too if it is short.
¥ internationalMenus package available thanks to Andreas
¥ bunch of fixes from all sorts of people -- thanks v. much.
¥ TeX::indentLine now operates 
¥ smarterSource will be activated much earlier at startup if you use 
  it.
¥ you may need to remove your preference setting for 'package::loaded'
  for things to work correctly wrt turning packages on and off -- this
  is due to some internal changes in the fc1p2 release.
¥ added dialog::yesno which returns 1,0 or error rather than the built in
  askyesno which you always have to use '== "yes"' with.
¥ electricMenu and shell improvements/fixes (thanks Frederic)
¥ latexSizes has user-specifiable bindings
¥ Diff mode copes with context-sensitive Diffs, and has a special 
  preference for them.  also for directory comparisons now.
¥ Some more international-menus/keys improvements.
¥ better and new electric completions in TeX mode
¥ added the 'alpha::package disable' subcommand.  This allows you to 
  specify a script to be evaluated when the user disables a package.
¥ 'blink' shows some context if the blink location is offscreen.
¥ menu::uninsert proc so you can remove previously inserted items.
¥ better Tcl completions
================================================================================ 
= 7.0fc1 released 
================================================================================ 
¥ useful new proc 'app::isRunning list-of-sigs ?name? ?sig?' which 
  returns 1 if an app with one of the given sigs is running, 0 
  otherwise.  Also if you pass it the name of a variable (or two).
  They are set to (using upvar) the name of the app and the actual
  sig of the app.  This proc uses a good regexp rather than scanning
  the 'processes' list one element at a time.

Remember: if your mode/menu/extension needs a feature from a new 
release of Alpha, just add the line:

	alpha::package require Alpha 7.0b4p2
	
or something similar.  Additionally the installer can use the
optional flag '-require {Alpha 7.0fc1}' to warn the user on
installation.

¥ some fixes from Johan (filesets etc)
¥ keyboard pop-up in international prefs.
¥ greek keybinding fix for TeX mode
¥ betterTemplates improvement
¥ minor Tcl::Markfile fix
¥ latexSizes package available
¥ simple international keyboards pop-up thanks to Andreas.  If your 
  keyboard isn't there, define a new 'keyboards' array entry.  See
  international section of the manual for details.
¥ some purgeable resource fixes from Andreas
¥ completion proc uses the current mode's wordBreak definition rather
  than a default (TeX mode completions work properly again)
¥ carriageReturn fixes a long-standing beginning of comment-line bug.
¥ improved 'new' and Calc mode a little bit.
¥ handleReply now uses a queue rather than a stack.  Also 
  'currentReplyHandler' always adds to the end of the queue unless
  you give it an optional parameter '1' which says add only if there
  are no duplicates.
¥ alpha downloads menu improved, and finds the downloaded installer 
  more robustly.
¥ fixed hierarchical fileset update bug due to not storing all info
  in the cache.  On restart, new submenus wouldn't actually work 
  before, until you rebuilt the entire menu.
¥ Tcl-dbl-click faster now.
================================================================================ 
= 7.0b4p1 released 
================================================================================ 
¥ a few 'switch --' bugs fixed (you should nearly always add '--' after 
  regexp, switch etc for safety ;-)
¥ prefs menu looks nicer
¥ proper unix.tcl included
¥ changed DeskTop to Desktop in some Alpha dialogs (will be in next 
  non-patch release).
¥ describe mode fix for modes not registered as packages (Text, PS, etc)
¥ disabling of the current-mode menu when there's no window.
¥ bindings opt-p and shift-opt-e for pi and e in Calc mode.
¥ Updated to mercutio mdef 1.3.4 (again in next non-patch release only)
  fixes bugs, looks better with OS 8.
¥ added two icons
¥ made a dialog resource purgeable that wasn't but should have been (777)
¥ renameTo moved to file menu (as a dynamic item)
¥ added ctrl-m binding to 'nextMatch'
¥ few internal changes.
¥ removed some obsolete stuff from "Alpha Commands"
¥ improved alpha downloads menu
¥ docProjects no longer require newDocuments
¥ C++ marking improved
¥ dialog::findApp bug-fix
¥ llindex more robust.
¥ gnuplotMode.tcl works with 7.0 again (unofficial version)
================================================================================ 
= 7.0b4 released 
================================================================================ 
¥ saveHook backup-fix
¥ related document-projects improvements
¥ globalMenus fix
¥ removed compatibility.tcl
¥ specialkeys fix
¥ number of useful fixes from Johan
¥ 'don't show log' in installer actually works now!
¥ 'file rename' in file-utils menu
¥ textures interaction fixes
¥ appPaths.tcl fixes
¥ fixes from Tom Fetherston
¥ new hook 'launch' with which you can register to be called when an 
  app with a given sig is launched: hook::register launch myproc $sig
¥ extension documentation improvements
¥ auto_reset called by rebuildTclIndices (but not by auto_mkindex since
  standard Tcl doesn't do that)
¥ HTML + related modes updated from Johan.
================================================================================ 
= 7.0b3p1 released 
================================================================================ 
¥ Tcl, C++, TeX, Shel mode improvements
¥ Key-binding fix (one old one new)
¥ 'special keysÉ' menu item
¥ latex mode 'choose command' currently removed.
¥ -provide {pkg version pkg2 version ...} install script flag now 
  available.  This checks that there isn't a newer version already 
  installed.
================================================================================ 
= 7.0b3 released 
================================================================================ 
¥ bunch of fixes from Johan
¥ package-index is auto-rebuilt if Alpha version changes and it isn't uptodate
¥ startup improvements (more robust)
¥ Tcl, C++, TeX mode improvements
¥ install flag -forcequit
¥ install flag '-rebuildquit' is ignored now.  Alpha always rebuilds and asks
  if you want to quit (unless -forcequit in which case you must quit)
¥ the rebuilding process takes place once your install script has completed.
¥ menu::buildSome cleaner now
¥ bunch of other fixes improvements from Johan, Tom
¥ HTML, Frontier, Javascript modes improved.
¥ Diff mode improved.
================================================================================ 
= 7.0b2p1 released 
================================================================================ 
¥ '-exact' flag supported by package require
¥ miscellaneous minor fixes.
¥ some 'unix' code now in coreFixes.tcl, rest improved and no longer needed
  at startup
¥ recursiveRm gone.  Replaced by '-r' option to rm.
¥ diff mode no longer requires both windows to be present to synchronise
  movement.  For example you may open a .diff file and look at it.  Then
  you can open the left diff window (using a menu item).  Diffs in that
  file are subsequently highlighted.  Then you can locate the right diff
  window and continue...
¥ package help item can now be:
  file "name"  --- a file in the Help folder
  [script] --- a script to open/edit the help file (usually jump to a mark)
  text --- a lot of text which will be put in a window for you
¥ small package::require fix (when errors happened)
¥ small mode-file matching improvement for Unix eol files.
¥ smartPaste better
¥ tclMode, C++ mode better
¥ package menu quicker --- abandoned the invisible non-help items since
  with the new 'help' package sub-command it's very easy to add help.
¥ wwwMode is now wwwMenu (why wasn't it always?? -- thanks tom)
¥ Tcl mode has surroundwithbullets again
¥ paste, supersearch improvements
¥ removed silly 'indentFollowsTab' flag, simplified a number of indentation
  routines.
¥ latex mode simplifications
¥ new proc 'elec::replaceText'
¥ C++ mode has a work-around in indent-line for an Alpha-core bug.  
  Activate the new flag in the mode-prefs to use it.
¥ diff mode patching with only one of two windows present.
¥ diff flags preference changed from global to Diff mode var.
================================================================================ 
= 7.0b2 released 
================================================================================ 
¥ a misc dialog fix
¥ word completion improvement
¥ icons for python and supercard modes
¥ installer more robust to systemcode changes
¥ some searching fixes (but see the 'supersearch' package too)
¥ 68k resources available now.
¥ modes with <mode>::correctIndentation defined have smart pasting if
  you install the smartPaste package.
================================================================================ 
= 7.0b1p2 released 
================================================================================ 
¥ ${mode}::startPara, endPara are used by fillParagraph if they exist.
¥ paragraph filling in Shel mode
¥ added international prefs, and note in manual under International Users.
¥ prefs dialogs handle item grouping
¥ installer can remove directories
¥ installer dialog re-sizes better
¥ Tcl mode can do remote stuff
¥ a few contributed bug-fixes (thanks!)
¥ added help sub-command to alpha::package to help packages locate help files.
¥ recent files menu much faster building
¥ appPaths.tcl imporvements
¥ error log options
¥ cache sub-dirs work ok
¥ renamed some of the package index stuff --- all stored in one subdir in
  the cache now.
¥ cache improvements
¥ alpha now prefers mode procs to be called '<mode>::markFile', 
  '<mode>::electricLeft' etc.  This will make things much more efficient
  and simple when Alpha upgrades to Tcl 8.  
¥ better Tcl::electricLeft
¥ new takes optional arg '-m <mode>' to set the mode of a new window 
  directly.  It also now returns the actual name of the window created.
¥ alpha remembers mode menu changes again now---newly introduced bug ;-(
¥ replace in fileset handles regexp and case-insensitive now
================================================================================ 
= 7.0b1p1 released 
================================================================================ 
¥ auto-loading extensions treated differently (extension without startup code)
¥ a menu fix
¥ menu::buildSome better
¥ a local directory '${HOME}:AlphaPrefs:' takes precedence over the one in
  the system/prefs folder if it exists.
¥ template insertion with no stops bug fixed
¥ package version checking/handling better
¥ TeX problems fixed
¥ improvements to Shell mode
================================================================================ 
= 7.0b1 released 
================================================================================ 
¥ various fixes to TeX mode
¥ ftpMenu improvements, app dialog too (thanks Johan)
¥ Tcl mode stuff from Tom
¥ help file improvements
¥ electric menu better
¥ diff mode improving...
¥ few other minor problems
¥ added key symbols for a few standard bindings to menus
¥ diff mode much better.
¥ fixed startup problems
¥ alpha package deals with extensions, modes and menus
================================================================================ 
= 7.0a4 released 
================================================================================ 
¥ package uninstall command now exists (see end of the Packages Help file)
¥ rename package to alpha::package to avoid problems if Alpha uses Tcl 8.0
¥ Menus directory is now recursively scanned.
¥ changed some Tcl-mode menu bindings
¥ other fixes from Tom, Johan.
¥ rewrote Alpha's mode and menu loading scheme to be more like the one for
  packages.  This is altogether better.  Since we have to rebuild indices
  when we install something new, we might as well extract the startup
  information.  Hence there are new commands 'alpha::mode' and 
  'alpha::menu' which behave like 'alpha::package' in that they declare
  a few required things (name, version, dummyProc, extensions etc.) and
  contain an optional startup script.  Now on startup Alpha doesn't need
  to scan the modes and menus directories.  Big time-saving!
¥ made package-menus a separate menu item --- they are a different kind of
  thing, since they can be turned on and off at will (unlike packages which
  usually require a restart), and the user may wish to access them more
  often.
¥ uninstall works ok now.
¥ new latex mode
¥ fixed some diff mode bugs.
¥ new combined help file 'extending alpha'
¥) keys::toBind has problems with modified bindings.  This is the problem:
	'eval bind [keys::toBind /1ÇXÈ] refresh' 
works ok, but
	'eval bind [keys::toBind /1<UÇXÈ] refresh' 
doesn't, since 'shift-1' is in fact '!', so we need /!<UÇXÈ, but it will
work if we have 'ctrl' as well as shift (for some reason...).  I'm not 
too sure how to fix this.

Fixed keys::toBind now, but in a keyboard dependent way (I think).  I don't 
think there's any other way.  There are two variables keys::mapShiftBindFrom 
and keys::mapShiftBindTo which contain the mapping required.  Perhaps these 
should be put in an 'advanced' preferences dialog.

================================================================================ 
= 7.0a3 released 
================================================================================ 
¥ Reorganised SystemCode and UserCode directories.  Removed a lot of 
  obsolete code and put it in the 'Compatibility' directory, so it's 
  still there if anyone wants it.  
¥ Modified basic word-completion 
  procedures and added general purpose indentation, electric and 
  template code.  Some of the new code merely replicates the 
  functionality of the old, some is completely new.  All of it is very 
  easy to extend and enhance with new templates, completion 
  mechanisms,É The idea is to keep Alpha's core code simple, but allow
  people to add things on without having to mess with that core too 
  much.
¥ Added similarly extensible option-titlebar-click procedures.
  Pop-up menu: to look for related files, option click in a window's titlebar 
  for a list of #included files, or files in the same directory or files 
  which form part of the same TeX document (it's a mode-dependent menu).
¥ Added regisearch.
¥ Simplified the flags/vars/mode/global dialog code.  It's now easy to 
  use for your for packages which aren't modes - so you can add an extra
  panel in the global options dialog with the name of your package.  
  Also added a new option: previously if 'menuFlags($var)' was set 
  then 'var' was one of the given list of items.  Now, that is still true,
  but separately, if 'flag::options($var)' is set, then var appears to
  the options dialog as one of the given list of items, but behind the
  scenes is just an index 0,1,2, etc. into that list.
  Finally the 'mode' dialog can also be used by separate packages which
  do not keep a copy of all their variables in the global scope.
  You just do "dialog::pkg_options Pkg" where all your vars are 
  stored in 'PkgmodeVars'.
¥ Added 'package' commands.  A simple package should just contain a 
  single line 'alpha::extension Pkg 0.95' somewhere in its file for all
  auto-loading, activation, deactivation, ... to work correctly.  Such
  a line will cause the package to be loaded at startup.  A nicer 
  package will also provide the script:
  
  	alpha::extension Pkg 0.95 script
	
  where 'script' is a script which does what is necessary to 
  initialise the package so that all other capabilities can be carried
  out through autoloading.  A simple example might be:
  
    alpha::extension Compare 1.0 {
		menu::addTo Compare winInPlace
	}
	
  which would add an item to the compare menu which when selected 
  would call the procedure 'compare::winInPlace'.  This means the
  entire file ("compare.tcl" or whatever it might be called) is only
  loaded when used.  That's obviously a bit better, so packages are
  encouraged to use this latter technique.
  
  Packages may require or test the existence of other packages.
  Just use:
  
    alpha::package require VinceAdditions 7.82
	
  or
  
    if [alpha::package exists VinceAdditions 7.82] { ... }
  
  Version numbers are now handled as in standard Tcl 8.  If a version
  number appears incompatible, an error occurs.
  
¥ Added hook and cache procedures.
¥ Bound 'opt-P' in the Tcl menu to find a procedure definition using
  command completion in the status window.
¥ Added hooks so packages can put items in the 'current mode' and
  'global' menus.  The latter is especially useful for packages.
¥ Added proc 'newPref' which should be used instead of 'newModeVar'
¥ Package system streamlined somewhat, version numbers work a bit
  more like Tcl.
¥ Removed old install menu, and install proc.  This means there is
  no way to select between latex2e and latex2.09, and no way to
  install the old electric-alias code.  Perhaps someone won't like
  that.  TeX mode can always add a modeVar to toggle between 2e and 
  2.09 if people actually use the old stuff any more.
¥ Alpha now starts up ok with 'packages disabled' (hold down shift)
¥ Added a trial key-binding dialog from HTML mode.
¥ Note a subtle change due to the new hooks procedures.  ChangeMode
  hooks are only called when the mode does actually change.  The old
  behaviour was odd (they would also be called on activateHook and
  some other events).  Modes (such as TeX) which relied on the old
  behaviour must be fixed ('upgraded' ;-).
¥ Split off all mode-completion routines into a separate directory.
  They are only loaded when necessary.
¥ Added a 'coreFixes.tcl' file which contains workarounds for bugs
  in Alpha's hard-coded procedures.
¥ Major overhaul of TeX, Bib modes to incorporate a lot of 
  code: integrates with filesets better, more searching capabilites
  for bibliographies/citations.  Also fixed up those modes for
  the new Tcl scheme.
¥ Fixed problem with flags dialogs (thanks Tom)
¥ Fixed bug in activateHook
¥ Added dynamic menu item for 'spellcheckSelection' (use Ctrl)
¥ Added 'Install' menu.  Any file whose name ends in ' Install' or 
  ' INSTALL', or whose first line contains the word 'install' (any 
  case) will be opened in the new 'Inst' mode.  This mode has an
  install menu, which will allow easy installation of the package
  to which the window belongs.
¥ Fixed a couple of subtle bugs in the dialogs code.
¥ mode::init hooks are called when a mode first starts up.  You can
  add new mode vars, manipulate menus etc.  However: mode-vars are
  not yet global, and menus are not yet in the menu bar.
¥ Incorporated numerous fixes and improvements from Johan.
¥ Improved package-index-rebuilding.  Now when a 'package ifneeded'
  command is reached, the 'source' command is aborted, using a 
  'return -code return' command.  This means the rest of the file is
  not sourced.  This is both quicker and less likely to cause trouble.
¥ Install menu code moving along.  Open any file whose name ends in
  "Install" to have a look.
¥ Fixed subtle startup bug; the list of modeVars was being reset.
¥ Decent installation dialog now.  Reorganised code into 'install.tcl',
  'package.tcl' and 'procUtils.tcl'.  Probably still some bugs in the
  install code.
¥ documentation fix: 'select' can take an optional parameter '-w win' 
  (very useful for diff mode)
¥ Bunch of fixes from Tom.
¥ Made TeX mode work properly with new scheme.  This involves replacing
  all 'insertText' with a special TeXinsertText which sends things to the
  new template scheme.  Also, since the template scheme automatically
  jumps to the first template, lots of code is simplified: one can replace
  set p [getPos] ; insertText "big insertion" ; goto $p ; nextTabStop
  by just 'TeXinsertText "big insertion"'  Menu bindings for nextTabStop
  etc aren't completely setup yet.  This may have to wait until we have
  proper user-selectable bindings.
¥ Install code even better now.  Can install large folers of code or 
  single files.  Add 'install' anywhere to the first line of a .tcl file
  which isn't in Alpha's hierarchy to check out the new code to install
  a file like that.
¥ Modernised a bunch of modes (thanks Johan)
¥ Added numerous fixes from Johan and Tom
¥ Install code can now be over-ridden with various options.
¥ package-index-rebuilding further improved, so 'package provide' will
  now also abort a source if required.
¥ Recalculate the auto_index before rebuilding it after installing
  a package.
¥ saveasHook now correctly uses both oldName and newName as parameters.
¥ Added 'auto-install' feature.
¥ Added couple of missing print procs.
¥ Modified global menu, including a flags sub-menu now.
¥ Added some icons and stuff to the 'newMenuIcons.rsrc' file (e.g. for voodoo)
¥ Improvements to installation code. New facility to open a file once on
  starting Alpha.
¥ Diff mode much improved.
¥ Beginnings of tutorial for writing new modes/packages.
¥ Lots of small stuff...
¥ Beginnings of general binding procedures; see dialogs.tcl
¥ Binding procs work now, at least for elec-code.  Will need some changes
  to integrate back into html mode.  See config:global:elec-bindings for
  an example.
¥ Further package improvements.  Various menus are now packages.  This leads
  to a minor problem: these menus can be turned on and off in two different
  ways.
¥ Installation scripts can now use '-remove' to remove obsolete files too.
¥ Fixed up TeX mode a bit more, removing obsolete code and files.
¥ New icons in resource; you must install them.
¥ Improvements to installation scripts; '-rebuildquit' and '-require' flags.
¥ Improved pascalMode.tcl, diffMode.tcl.
¥ Distribution is correct now (fixed a script problem I had)
¥ Improved mode tutorial
¥ Vars which end in 'Mode' now use a pop-up menu to select a mode when used
  in any preferences dialog.
¥ Improved 'twiddle' command.
¥ Very cool new dialog features.  Any item which ends in 'Folder' is a
  folder preference, and has a 'SetÉ' button which allows it to be set
  directly from the dialog box.  This allows a mode to keep all of its
  preferences in one place (no need for the user to discover 'App Paths').
  Second, you can register new flag types in addition to the basic
  'flag' and 'variable'.  Currently only the type 'binding' is setup.
  You just use 'global::newType binding' and can subsequently use
  'newPref binding ...'.  How does this work?  Well, you need two new
  procs:
  
	proc dialog::specialView_binding {value} {
		# convert 'value' to non-editable textual form for the options dialog
	}
	proc dialog::specialSet_binding {name} {
		# prompt the user for a new value for the variable 'name'
		# use global::getFlag, to get its value, and 
		# global::modified 'name' 'value' to tell the dialog that
		# it was modified (if the user cancels, this change is later
		# ignored)
	}

  New types will just need procs dialog::specialSet/View_${type} ...
  
¥ Improved Tcl file marking.
¥ Added type 'file'.
¥ App Paths menu is now obsolete, so it has been removed.  TeX, Perl and 
  Mail code updated to use new file/folder prefs.
¥ package code checks version numbers now.
¥ Fixed major, though very infrequent, bug in newPref
¥ You can now lappend 'unset' variables to modifiedVars; when Alpha quits
  such variables are removed from the user defs if they are still unset.
  (otherwise the current value is of course saved).
¥ More menus are dynamically put together.  Avoid the use of 'addMenuItem',
  especially to the Utils and Config menus.  You're better off using
  menu::addTo 'name' 'items' which also allows you to add dynamic items
  and sub-menus.
¥ Modified/cancelled special flags are set/unset properly now.
¥ New type 'menubinding' and 'binding'.  Menu-bindings must contain
  modifiers unless they are special keys, normal bindings need not.
¥ Other minor changes
¥ Added listvar, array and Sig types
¥ Forced to split global flags into two sub-blocks, since Alpha chokes on
  calls to 'dialog' which are too long.
¥ dialog::pkg_options can now be used to edit the contents of any array:
    dialog::pkg_options "" "Title of dialog box" 1 'array-name'
  changes are recorded and will be remembered on startup.
  (you can skip items by setting 'set ${array-name}Invisible(item) 1')
¥ fixes couple of recently introduced bugs
¥ added 'SearchPath' type: a list of folders
¥ made it easy to create and manipulate flag-menus and option-menus from
  pre-existing mode/pkg prefs.  (e.g. two of the filesets menu utilities
  submenus use the new code)
¥ menu::addTo is more robust
¥ reorganised global flags menu
¥ can select prefix-chars in the key-binding dialog (emacs-ish ctrl-x ctrl-s)
¥ can select 'escape' as a prefix char too
¥ fixed stupid bug in dialog
¥ added 'quick find regexp' to search menu
¥ made the printer menu an optional package
¥ a few fixes from Johan, Tom and me.
¥ synchronise global menus and packages.
¥ version comparison works with alpha/beta/devel/final-candidate
¥ some new icons, dialog improvements, binding procedures
¥ new 'prefs::addPackage' proc which will add an item '${pkg} PrefsÉ' to the
  global menu, and handle manipulation of a dialog for all '${pkg}modeVars'
¥ installer creates a log window if desired.
¥ installer handles 'ignore' files/dirs better now.
¥ How to deal with mode-vars which over-ride globals?  There are a number of 
  problems here: first it _is_ useful to have a global preference, but then 
  have, in one mode, that global over-ridden.  That happens automatically 
  right now.  The problems arise when you switch to another mode: not only 
  is the global var _not_ set to its old value, but the global var is in 
  fact unset.  Any ideas on how to resolve this?  (Tcl 8 and namespaces 
  would make this easy, I think).  I've put a solution to this in
  'changeMode' now.  It maintains a list of those globals which are over-
  ridden by the current mode, and resets their values when that mode
  switches out of scope.  It's actually not that complex or time-consuming
  a processs which is good (changeMode already does too much!).  I still
  anticipate a better solution if Alpha upgrades to Tcl 8.
¥ new install feature.  Previously if the first line of the 
  'OPEN-TO-INSTALL' (or generally *INSTALL) file contained 'auto-install',
  it would open iconified and the *install.tcl script sourced immediately.
  This is still true, but further if the first line of the *INSTALL file
  contains auto-install-script, then the *INSTALL file itself will be
  sourced (make sure that first line starts with a '#' or there'll be an
  error).  This removes the need for silly one-line files with 'auto-install'
  at the top.
¥ Number of small bug-fixes and improvements.
¥ Tcl proc/var completion improved. (context sensitive)
¥ codewarrior menu improving...
¥ java, C++ mode improvements, Java completions
¥ gnuplot mode updated even more.  Added 'editPrefs' hook.
¥ added file creator->mode mappings e.g. 'set modeCreator(GPLT) GPLT'
¥ added tclIndex files to distribution for first time users
¥ dialogs support arrow keys for bindings/menu items.  Seems as if menu items
  don't quite work in menus (I guess they aren't 'special' keys)
¥ better use-package menu (but works around a stack of nasty menu-bugs)
¥ bug fixes to few dialogs.
¥ colour dialog items grouped at end for modes.
¥ renamed 'modifiedModeVars' to 'modifiedArrayElements'; it was being used
  in so many places where 'Mode' was not relevant that the new name is more
  clear.  You can still use the old name, but the newer one is better.
¥ global/mode over-riding of variables completely transparent now.  One key
  feature is the changing a mode-specific value must happen in the mode-prefs
  dialog, and changing a global value must happen in the global-prefs dialog.
  If you do change a global value while it is over-ridden, the global value
  does change, the mode-value does not (and remains in force), and the user
  is warned that they adjusted a hidden variable, not the mode one.  Again,
  I'm sure this variable-scope-mess would be much alleviated with namespaces.
¥ the above change meant the removal of 'generalElectricTab' and 
  'modeSpecificElectricTab', to be replaced by a single global flag 
  'electricTab', which is over-ridden by mode-specific flags of the same 
  name.  This global flag is off by default.
¥ fixed minor colour problem in dialogs
¥ url downloading will work if you set your downloadFolder correctly
¥ cleaned up some temporary code.
¥ diffMode fixes, install fixes, dialog fixes
¥ url/www/ftp improvements
¥ You can hopefully use Alpha to download files from my web site now,
  although there are probably still bugs in the code.
¥ WARNING: completely new, incompatible replyHandler registration.
¥ What to do about 'handleReply'?  it handles apple-event replies in some 
  sort of queued fashion, and is used variously by the ftpMenu code, 
  voodooMenu, and there is also a default in appleevents.tcl Presumably 
  there should be one 'handleReply' which somehow knows who sent the 
  original event and passes the reply on to a given handler.  I've
  sorted this now.  There is one handleReply with which any other
  handler may be registered using 'currentReplyHandler procname'.
  That proc takes one argument, the reply which is to be handled
  (maybe).  If it does handle that reply it should return '1', else
  anything it likes.  You should call 'currentReplyHandler' just
  before every apple-event call which has a queued reply.
¥ Used a different mechanism for rebuild package indices so I don't have
  to alter smarterSource in any way.  I now use 'return -code 11' to
  abort source statements.
¥ Turned 'smarterSource' into a package rather than part of the core.
¥ Rewrote some of the menu-building code.  Use 'menu::insert' to add
  items to pre-existing menus.  It's more tk-like now.
¥ recentFiles menu is now a package.
¥ fixed nasty dialog bug in multi-page ones (hadn't reset some vars)
¥ made dialog code more robust to index vars badly set.
¥ fixes from Tom, Johan (in particular ftp code is much improved)
¥ even better regIsearch (very useful proc Tom's been improving)
¥ really made dialog code robust to index vars.
¥ get files from web/update list of packages should all work ok now
¥ numerous small fixes
¥ fixed up unknown procedure to be more robust (nabbed from Tcl8)
¥ '!!' works in the shell window now.
¥ better synchronisation of package activation with the menu
¥ better tcl mark file
¥ appPaths.tcl reorganised
¥ got code ready for 7.0 release (renamed NewMenus/Modes/System etc.)
¥ renamed 'package' to 'alpha::package'.  This is to make it less hassle
  if Alpha upgrades to Tcl 8.0.
¥ fixed menu dialog bug, install files bug, rebuild indices bug.
================================================================================ 
= OLD STUFF BELOW
================================================================================ 

Problems/projects:
	¥ fileset fast word count is gibberish.
	¥ scrollbars of split window get confused
	¥ batch multi dir 

================================================================================ 
= 6.52 Released!
================================================================================ 
¥ Incompatibility w/ Kaleidescope fixed.

================================================================================ 
= 6.51 Released!
================================================================================ 
¥ New java mode.
	
================================================================================ 
= 6.51b14 5-2-96
================================================================================ 
¥ Fixes some problems introduced w/ filesets in last version.

================================================================================ 
= 6.51b13 4-13-96
================================================================================ 
¥ Fixes to fortran and perl modes.
¥ The updated java mode should be in this version...
¥ Updates to fileset procs. You may need to remove your preferences...

================================================================================ 
= 6.51b12 4-3-96
================================================================================ 
¥ 'showInvisibles' now available from mode popup in status bar.
¥ can again drag to end of buffer.
¥ Java mode updated.
¥ FTP'd files no longer give the "Wrap?" dialog.
¥ Directory scan in find dialog easier to use.
¥ word-match works w/ non-multi batch

================================================================================ 
= 6.51b11 3-31-96
================================================================================ 
¥ Many of the bug fixes hadn't gotten copied into the release dir for b10. 
  They are here now.

================================================================================ 
= 6.51b10 3-31-96
================================================================================ 
¥ 'rebuildFtpMenu' now works correctly out of the box.
¥ fix for 'endLineSelect'.
¥ Removed latex palette item and added help item.
¥ Easier to decide not to tearoff menus.
¥ HTML fixes.
¥ Perl filters work again.

================================================================================ 
= 6.51b9 3-31-96
================================================================================ 
¥ Command-click on a URL now selects it and sends off to internet config.
¥ regular expression search bug introduced in 6.21 fixed.
¥ 'insertText' now properly preserves the "mark".

================================================================================ 
= 6.51b8 3-31-96
================================================================================ 
¥ Alpha now knows that the Internet Explorer understands open-URL events.
¥ "Keyboard" macros can now be named and saved.
¥ 'recentProc' now exists again.
¥ Bug w/ menu floats not always opening fixed.
¥ Up-to-date html docs.

================================================================================ 
= 6.51b7 3-31-96
================================================================================ 
¥ Floating point precision problem fixed in calculator.
¥ Innumerable Tcl bug fixes by Vince Darley.
¥ HTML mode 1.4.
¥ "Helper Apps" on Config menu allows helper apps to be reconfigured.
¥ 'search' now works w/ 'searchStart'.
¥ added 'tearoffMenus' flag.
¥ brace blink problem corrected.

================================================================================ 
= 6.51b5 11-26-96
================================================================================ 
¥ IC Menu now has a telnet item, works w/ NCSA telnet.
¥ 'coloring' now affects color-while-you-type.
¥ New HTML mode and docs.
¥ A myriad of other small changes.
¥ Includes new version of Mercutio MDEF, internet config.
¥ Cache of temporary ftp mounts points.
¥ Can turn off all caching of mount points.
¥ Can now create new files at ftp mount points.
¥ setFileInfo has new 'pathname' type.

================================================================================ 
= 6.51b3 8-26-96
================================================================================ 
¥ 'sendUrl' again works from the menu.
¥ 'matchIt' has optional param
¥ 'eventHandler' w/ no new proc returns current handler
¥ HTML menu can now be torn off.
¥ Torn-off mode menus automatically hide and reappear.

================================================================================ 
= 6.51b2 8-26-96
================================================================================ 
¥ IC Menu now contains a 'finger' item. Works w/ Peter Lewis's finger 
  program.
¥ New version of MDEF. Hopefully, this version won't crash.
¥ 'Move files' in HTML mode no longer remove empty lines in the moved files.

================================================================================ 
= 6.51 8-26-96
================================================================================ 
¥ Menus tear off!
¥ 'gotoFunc' added to Text menus, assigned old gotoMark key binding.
¥ 'cd' once again silently supplies the leading colon on relative 
  pathnames.
¥ Problem of loading 'prefs.tcl' a second time fixed.
¥ 'findFile' and 'getfile' now accept an optional argument that specifies a 
  default directory or file. 
¥ Titlebar popup now brings up findfile to correct dir or file.
¥ wordCompletion enhanced to allow underlines, and bound to F1.  
¥ includeFiles menu fixed.
¥ C/C++ func menu now includes include files.
¥ Documented 'setCreator' and 'setType' in shell help file.
  
================================================================================ 
= 6.5 Released - 8-23-96
================================================================================ 

================================================================================ 
= 6.22 8-19-96
================================================================================ 
¥ Another change to the C mode 'parseExpr'.

================================================================================ 
= 6.21 8-18-96
================================================================================ 
¥ 'regexp' now handles perl extensions such as \w in square brackets
¥ C, C++, and Java func expr fixes.
¥ C++ now default mode for .c and .h files. CodeWarrior and ThinkRef 
  default C/C++ menus.

================================================================================ 
= 6.2b17 7-31-96
================================================================================ 
¥ 'Recent' submenu added to AlphaLite.
¥ CW 10 will support extern apps! See here, young man.

================================================================================ 
= 6.2b16 7-31-96
================================================================================ 
¥ Fixed screwup in the latex funcs menu.

================================================================================ 
= 6.2b15 7-31-96
================================================================================ 
¥ Drag in read-only window no longer messes up hiliting.
¥ Triple-clicking is back.
¥ "Latex Guide" html version is back in full Alpha version.
¥ Codewarrior menu 'touch's file w/ IDE, so "Modification Date Caching" 
  *can* be enabled in the project preferences.
¥ The "Funcs" menu is back, and has now been reassigned the curly braces
  icon. The marks menu has been moved to the icon w/ the big 'M'.
  
================================================================================ 
= 6.2b14 7-31-96
================================================================================ 
¥ Electric left at end of buffer fix.
¥ Palette crasher fixed.
¥ Some attempt to fix the intermittent problems w/ menu font sizes that some 
  people has been made. If it doesn't do it for you, you can turn them off 
  via the global variable 'smallMenuFont'.
¥ Workaround for some of the color problems w/ the status window. 
¥ Closed hand appears immediately on drag.

================================================================================ 
= 6.2b13 7-31-96
================================================================================ 
¥ *Now* 'puts' to stdout is transparently ignored.
¥ The name of the 'Trash' eudora folder can now be changed.
¥ 'fillText' (and hence soft wrapping) now also respect the 'doubleSpaces' 
  flag.
¥ HTML 1.2 changes.
¥ Global config dialog smaller.
¥ The crash when opening and then closing an empty window on 68ks seems to 
  have disappeared.
  
================================================================================ 
= 6.2b12 7-18-96
================================================================================ 
¥ FTP and Fileset menus are back to where they should be.
¥ Help and palette menu items added for perl menu.
¥ Mail messages now show dates.
¥ Electric braces, returns, and semicolons now work in perl 
  mode. Added hierarchical help menu and palette to perl menu.
¥ electricC-blah routines are now just 'electric', and live in electric.tcl, 
  which used to be indentLine.tcl.
¥ HTML send-window can now tolerate windows w/ ' <n>' appended.
¥ Word-wrap crash w/ very long lines now fixed.
¥ Skew of Marks menu in dialog fixed.
  
================================================================================ 
= 6.2b11 7-18-96
================================================================================ 
¥ Changed 'winNames' back. 
¥ Fixed redraw problem when backspacing w/ palette visible.
¥ Changed bindings for (sendtence|paragraph)Region.
¥ 'puts' now null proc.
¥ Annoying flicker when selecting text gone.

================================================================================ 
= 6.2b10 7-17-96
================================================================================ 
¥ Added wdef w/ border for pre-system-7.5 users.
¥ Floats can now be bound to mode w/ -z.
¥ Date routines fixed for year 2000 :-)
¥ winNames -f will no longer have ' <n>' appended.
¥ Removing 'All' from the popup marks menu now only removes the front 
  window's marks.
¥ Various fileset and html fixes.
  
================================================================================ 
= 6.2b9 7-7-96
================================================================================ 
¥ More latex changes, improvements, and documentation.
¥ Alpha can now be "deconstructed". See here.


================================================================================ 
= 6.2b8 7-7-96
================================================================================ 
¥ Floaters close if their menu is redefined.
¥ "Suffix Mapping" menu item under Config allows suffixes to be reassigned 
  among modes.
¥ ftpMode listing name formed differently
¥ New latex mode. 2.09 support is back.


================================================================================ 
= 6.2b7 6-29-96
================================================================================ 
¥ fixed diff mechanism
¥ a couple of fixes for html
¥ "Rebuild Tcl Indices" no longer picks up commented-out procs.

================================================================================ 
= 6.2b6 6-28-96
================================================================================ 
¥ faster scrolling behind floating windows.
¥ added '-n' option for floats.
¥ Big reorganization of Tcl code. See here.
¥ Fixed batch dir searches.

================================================================================ 
= 6.2b5 6-23-96
================================================================================ 
¥ fixed scrolling behind floating windows, although still slow.
¥ added 'float' and 'unfloat'.


================================================================================ 
= 6.2b4 6-23-96
================================================================================ 
¥ New latex changes.
¥ fixes for carriage return problem introduced in b3.

================================================================================ 
= 6.2b3 6-13-96
================================================================================ 
¥ Added new 'substituteWindow' as alternate to 'chooseWindow' in menu.
¥ Changed dynamic loading mechanism, saves memory, should work the same 
  unless you access auto_index or the 'tclIndex' file.
¥ added a call to 'savePostHook'.
¥ added ftp (Anarchy) menu. No docs yet.

================================================================================ 
= 6.2b2 6-8-96
================================================================================ 
¥ Function-call colorizing fixes.
¥ Changed windows menu a bit.
¥ sendUrl didn't work if HTML mode hadn't been used. Fixed.
¥ 68k 'eventHandler' finally fixed!!
¥ Remove marks handles metachars.
¥ Latex 3.2b9.

================================================================================ 
= 6.2b1 6-8-96
================================================================================ 
¥ Fixed new-fileset menu item from find dialog.
¥ Function-call coloring available for C and C++ modes. 

================================================================================ 
= 6.2a6 6-7-96
================================================================================ 
¥ Fixed glob on other volumes bug.
¥ Mercutio 1.3b9.

================================================================================ 
= 6.2a5 6-7-96
================================================================================ 
¥ Fixed blank chars if typing as new window opened.
¥ Coloring bug with multiple-line colorized hunks of text fixed.
¥ 'printHeaderProc' replaced w/ 'printLeftHeader' and 'printRightHeader'.
¥ Fixed mode suffix bugs introduced in a4.

================================================================================ 
= 6.2a4 6-6-96
================================================================================ 
¥ Moved to CW8.
¥ Moved to Mercutio 1.3b6
¥ Added listpick interface to IC menu urls.
¥ 'immediateSend' now menu flag for eudora mode.
¥ Current mode can be changed via "Config:Current Mode:ChangeÉ"
¥ Current mode suffixes can be changed via the "Config:Current Mode:FlagsÉ" 
  dialog.
¥ Added all of Vince's fileset stuff.
¥ HTML mode changes.

================================================================================ 
= 6.2a3 2-15-96
================================================================================ 
¥ '-c' option added to menu command tells menu routines to ignore 
  meta-chars.
¥ Added 'pushd', 'popd', and 'dirs' shell commands.
¥ String-coloring bug fixed.
¥ New LaTeX version.

================================================================================ 
= 6.2a2 2-15-96
================================================================================ 
¥ Memory corruption problem fixed.
¥ Changed html.tcl htmlMode.tcl sendUrl to use 'browserSig' var instead of 
  path.
¥ getWinInfo gets 'currline'.
¥ Enter key now sort of emulates what I'm told it does in Brief.
¥ Added HTML table row to tab-delimited format and back.
¥ 'dialog's popup menus no longer are scanned for command equivalents.
¥ searching for reg expr '\\reg' will now match '\reg'.
¥ Batch search now works for single-file searches as well.

================================================================================ 
= 6.2a1 2-15-96
================================================================================ 
¥ 'OpenHeader' added to CodeWarrior menu.
¥ option-mouse-down in code-warrior files now pops up a headers menu.
¥ "Find In Next File" now command-M in AlphaLite as well.
¥ Added 'nameFromAppl', which allows path to be found from creator.
¥ Many pathvars tossed.
¥ Added 'doubleSpaces' flag.
¥ 'addAlphaChars' allows characters to be added to definition of 'isalpha' and 
  'isalnum'. 
¥ Regular expressions can now use '\w', '\W', '\s', '\S', '\b', '\B', '\d', 
  and '\D'. All but '\b' and '\B' can also be used inside of character classes.
¥ Delete filesets now works on enumerated filesets as well as non-enumerated.
¥ Improved HTML mode.
¥ Global variable substitution now performed on 'backDir'.
¥ Holding down the shift key during startup tells Alpha to skip 
  preferences files.
¥ 'edit' now accepts '-c' option that tells is to bring existing files to 
  front without asking if duplicate needed.
¥ glob bug fixed.

================================================================================ 
= 6.12 2-15-96
================================================================================ 
¥ Bad regular expression no longer complains for every file in fileset.
¥ Eudora alert annoyance removed.
¥ Support for Java syntax coloring and editing added.
¥ "Edit Nicknames" bug fixed.

================================================================================ 
= 6.11 2-11-96
================================================================================ 
¥ grep multi-file search/replace bug fixed
¥ 'special chars' color fix
¥ global menus
¥ nicknames w/ eudora
¥ Alpha now has its very own calculator.
¥ 'shell' param for setWinInfo
¥ thumb can no longer be dragged past max size of win (problem for win length
  greater than 32k).
¥ 'killWindowStatus' default now front window.
¥ 'moveInsertionHere' now deselects first.


================================================================================ 
= 6.1 2-1-96
================================================================================ 
¥ Added '.' and '\' to list of chars escaped for non-grep batch searches.
¥ String-coloring draw problem fixed (sometimes printed chars from next line on 
  current line).
¥ Another IC tweak.
¥ Another Fortran mode tweak by the many Toms.


================================================================================ 
= 6.098 2-1-96
================================================================================ 
¥ Fixed non-grep batch searching problem.
¥ Typing in strings now colored.
¥ TeX prefs split into two pages.
¥ Potentially evil bug fixed for modes that don't color strings.
¥ CodeWarrior flag problem fixed.
¥ Internet Config clients on other volumes should open now.

================================================================================ 
= 6.097 1-20-96
================================================================================ 
¥ Changed bindings for 'Iconify'.
¥ 'noShiftBinding' gone.
¥ 'removeSavedSetting' now saves modifed vars first.
¥ new scheme mode
¥ regModeKeywords can now color strings.
¥ Coloring for keywords, strings, comments can be changed in mode dialog.
¥ Version 3.1 of Tom Scavo's TeX mode.

================================================================================ 
= 6.0963 1-19-96
================================================================================ 
¥ Change in the preferences dialog.
¥ Back to caret to denote control modifiers in menus.
¥ Changed command equiv for searchNextFile.

================================================================================ 
= 6.0962 1-18-96
================================================================================ 
¥ Fixes 'Find' crasher.

================================================================================ 
= 6.096 1-15-96
================================================================================ 
¥ 3.1 beta TeX mode by Tom Scavo.
¥ radio buttons and gray outlines added to 'dialog'.
¥ 'Escape' selects Cancel button again.
¥ Hopefully, the crashing w/ simple key sequences on international 
  keyboards is fixed.

================================================================================ 
= 6.095 1-7-96
================================================================================ 
¥ Non-alphanumeric mailbox names handled.
¥ "Revert To Backup" added to file menu.
¥ Replace-all can now be aborted w/ command-.
¥ multi-line comment coloring problem fixed.
¥ Eudora and config menus continue to evolve. The eudora mode, especially, I 
  think is especially slick. Opening mailboxes large is still slow, but 
  everything else works pretty well.
¥ Improved CodeWarrior error reporting from John Dunning.
¥ New icons for function keys in menus. The 'control' icon is now 
  different (looks like a picnic table).
¥ 'wordWrap' and 'softWrap' subsumed into a single variable ('wordWrap'), and 
  accessed via a menu in the status bar.
¥ Non-regular-expression batch searches now work correctly.
¥ Config menu re-arranged. Flags and vars now set using dialog.
¥ New 'dialog' function.


================================================================================ 
= 6.094 1-7-96
================================================================================ 
¥ Row-col indicator changes again.
¥ Drag bar problems fixed.
¥ Eudora mode significantly improved.

================================================================================ 
= 6.093 1-6-96
================================================================================ 
¥ Row-col indicator works for >10000 lines again.
¥ Fixed open-file bug recently introduced.

================================================================================ 
= 6.092 1-6-96
================================================================================ 
¥ Command-click on title now gives enabled menu, result is sent to tcl proc
  'titlebar', currently opens the folder in the Finder.
¥ A few Eudora mode changes, now we have docs! 
¥ Other random, assorted minor fixes.

================================================================================ 
= 6.091 1-4-96
================================================================================ 
¥ region modifiers now taken notice of read-only status
¥ text menu alternation problem fixed.
¥ space and delete work intelligently in browser and mail modes.

================================================================================ 
= 6.09 1-4-96
================================================================================ 
¥ File and mode-selection popup are now in the status window.
¥ 'showPlatform', 'showRowCol', and 'showMode' are gone, in effect always on.


================================================================================ 
= 6.08 1-2-96
================================================================================ 
¥ Another menu re-configuration. Help menu gone, everything now under system 
   help menu.
¥ "Quick Start" doc added.
¥ The "Sort Lines" menu item (under Text) now alternates w/ "Reverse Sort".
¥ "Mode Info" and "File Info" popups separated. "File Info" still popup, 
  "Mode Info" now under Config.
¥ You can no longer bring a window to the front and drag it in one click. 
  Let me know if you disagree w/ this. I had several complaints about the 
  current setup.
  
================================================================================ 
= 6.07 1-2-96
================================================================================ 
¥ Internet Config warning (on startup) removed.
¥ drag warning narrowed.
¥ obscure 'addAppPaths' bug fixed.
¥ defaults for color picker added.
¥ Slight menu re-configuration.
¥ Command-click and command-double-click differentiated a bit better.

================================================================================ 
= 6.06 1-2-96
================================================================================ 
¥ Redraw bug w/ split panes fixed.
¥ Bugs w/ command-double-clicking and slow file loads (both added in 6.05) 
  fixed. 

================================================================================ 
= 6.05 1-1-96
================================================================================ 
¥ 'colorTriple' now takes an initial color.
¥ new routine icURL <URL> that passes arg to Internet Config, if present.
¥ command-clicking passes the text to Internet Config (doesn't yet work for 
  68k version).  
¥ New Internet Config menu. 
¥ New soft-wrapping feature.  Vars 'wrapLow', and 'wrapHigh'.
¥ 'Push' and 'pop' marks moved up a level in Search menu. Hypertext jumps 
  now call 'pushMark' before performing the action.

================================================================================ 
= 6.04 12-25-95
================================================================================ 
¥ Cmd-double-clicking procs can now notice a "control"
  modifier of the basic command-double-clicking. No mode yet uses this.
¥ Red and blue colors changed slightly.
¥ Eudora mode subject display glitch fixed.
¥ Fixed nastly little memory bug (which usually showed up while pasting 
  large chunks of text).
¥ XTCLs are gone. They will be replaced in the near future by the standard 
  Tcl extension mechanism. See Ray Johnson at SunLabs for more details.
¥ Bug inserting literals ampersands fixed.
¥ Discrepancy between two versions of 'menu' command fixed. Menuprocs are 
  called w/ two arguments, return value ignored.
¥ Tag files now always created type mac, prompt for wrapping tagwin no 
  longer occurs.
¥ If the first line of a file contains the text 'nowrap' anywhere in it, 
  the wrap prompt is not displayed, regardless of the line lengths.

================================================================================ 
= 6.03 12-11-95
================================================================================ 
¥ Including Pete Gontier's ClickWarrior, an init that vectors clicks in 
  CodeWarrior's project window to Alpha. See here for details.
¥ Fixed HTML display problem.
¥ Enhanced Fortran mode, mode-specific indentLine, fileset-specific 
  'cTAGS' from Tom Pollard. Also an 'emacs' smartMode in :Tcl:UserCode.

================================================================================ 
= 6.02 11-11-95
================================================================================ 
¥ Command-double-clicking on a URL now sends it to your web browser. See 
  here to customize.
¥ More of Vince Darley's Tcl code, new marking routines for C, C++, Tcl. 
  New rebuildTclIndices. (un)Commentbox(paragraph).
¥ Inserting text in keyboard macro doesn't mess up mark.
¥ Alpha menu icons don't pop up when other apps frontmost.
¥ "Recent Files" list can now be reset. Only one instance of a given 
  filename can now be in list.
¥ Added "Redefine colorsÉ" submenu off Mode. See manual.
¥ Added Vince Darley's fillParagraph and smarterSource code. 
¥ Added mode-specific prefs (not Vince's).
¥ Mail mode allows you to tell Eudora to quit notifying Alpha.

================================================================================ 
= 6.01 7-21-95
================================================================================ 
¥ 'repeatSearchBackward' and 'repeatSearchForward' now work correctly in 
  macros
¥ added/changed 'searchString'/'replaceString'.

================================================================================ 
= 6.01 7-21-95
================================================================================ 
¥ MacPerl mode fixes, new help files for MacPerl and BibTeX.
¥ Patterns menu from the find dialog now gets updated.
¥ "Drop¥PS" is now selectable from the print menu.
¥ Very rudimentary eudora interface added. Install via the 'Utils' menu.
¥ Added 'tileMargin' var so that different win styles, such as those of 
  'Aaron', look right.
¥ Added 'eventHandler' hook to allow Tcl scripts to respond to incoming 
  Apple Events.
¥ Latex bug fixed.
    
================================================================================ 
= 6.0 7-16-95! 
================================================================================ 
¥ Added 'Bib' to modes 'commentBox' recognizes.

================================================================================ 
= 6.0b28 7-16-95 
================================================================================ 
¥ Fixed some distribution problems.

================================================================================ 
= 6.0b28 7-16-95 
================================================================================ 
¥ Added 'Send Url' to Utils menu, moved emacs menu over to Mode.
¥ Fixed DOS-file crash.
¥ Fixed top-level HTML menu problem.
¥ New mode definitions for ADA flex/yacc
¥ New fixes/additions to Perl and BibTeX modes.

================================================================================ 
= 6.0b27 7-11-95 
================================================================================ 
¥ New (and final, for a while) latex mode.
¥ "Remove Saved Setting" no longer unsets the variable.
¥ Changed HTML mode icon to Netscape, added a "Send URL to Netscape" item 
  under the HTML URLs submenu.

================================================================================ 
= 6.0b26 7-4-95 
================================================================================ 
¥ Lock icon now redraws after resume.
¥ Another try at alleviating the annoying dialogs when using TPM 7.0.4.
¥ Another try at word-wrapping.
¥ A couple of drag-scrolling bugs in split-pane windows fixed.


================================================================================ 
= 6.0b25 7-4-95 
================================================================================ 
¥ New HTML version
¥ 'indentOnCR' now respected during word wrapping.
¥ bug fix in bibtex mode.
¥ Crashing bug w/ split windows fixed.
¥ Read-only 'lock' icon now above vertical scrollbar.


================================================================================ 
= 6.0b24 7-3-95 
================================================================================ 
¥ word-wrapping now uses vars 'wrapBreak' and 'wrapBreakPreface'.
¥ flags now work in C++ mode.
¥ New LaTeX version.
¥ "Find Options" dialog problems fixed.


================================================================================ 
= 6.0b23 7-3-95 
================================================================================ 
¥ 'Win Sets' are gone. However, you can entirely duplicate their behavior 
  by using 'Create Fileset From Wins' and 'Open Entire Fileset' under the 
  "FileSets:Utilities" submenu.
¥ Nasty little (real old) bug that caused the cursor to appear only briefly 
  after a command executed finally fixed.
¥ Moved 'hilite' out of a Search submenu.
¥ "Replace in Fileset" moved to control alternate of "Replace All".
¥ Bug w/ queued replies (usually seen w/ think project manager) fixed.
¥ Fortran comment coloring bug fixed.
¥ Split pane bug fix.
¥ Word-wrapping bug. 
¥ Fixed some hiliting bugs. In doing so, I broke scrolling when covered by 
  floating windows. For those of you that this affects, for right now I 
  say, "Don't Do That."
¥ Fixed "Goto Tab Stop" problem in TeX mode.
¥ 3D buttons have gone away. If you liked them, I suggest you get the "
  Aaron" init. This should also fix the problem w/ crashing on the original 
  portables.

================================================================================ 
= 6.0b22 7-1-95 
================================================================================ 
¥ Redraw fixes w/ multiple panes.
¥ Enable/disable emacs persists across executions.
¥ Changed buttons, etc.
¥ New version of latex code.
¥ Added 'Replace In Fileset" proc.
¥ Can now create filesets on the fly from the find window.


================================================================================ 
= 6.0b21 6-12-95 
================================================================================ 
¥ Addition of underline keywords for latex mode (not in place yet).
¥ 'word match' works w/ batch searches.
¥ Multi-file directory scans have option of text-only. 
¥ Final latex mode nearing completion.
¥ Small html and bibtex mode changes.
¥ Bindings w/ a shift, but not a command, control, or option, now work.
¥ 'latex' 2.09 proc works again....

================================================================================ 
= 6.0b20 6-11-95 
================================================================================ 
¥ Fix in 'showVarValue'.
¥ 'editMark' now creates marks if they don't exist.
¥ Print submenu changed, can now set default printer app.
¥ Clicking on drag bar of inactive window makes active and then continues 
  to drag.
¥ indentLine/indentRegion and lineToParagraph/paragraphToLine added to 
  Convert menu.
¥ sendOpenEvent takes an option that tells it to not wait for a reply.
¥ Comment colorizing better.
¥ Files w/ Projector's "ModifyReadOnly" flag set can now be modified.
¥ LaTeX mode almost finishedÉ

================================================================================ 
= 6.0b19 6-5-95 
================================================================================ 
¥ Popup menus from the 'prompt' command now correctly display spacers.
¥ Lots of new latex and perl changes/fixes. 'latex' in the 2.09 version 
  works now.
¥ 'alpharc.tcl' has been renamed 'prefs.tcl'. Probably the last name change
  in a while :-).
¥ Directory comparisons seem to be working on my machine...
¥ Printing through various apps allowed.
  
================================================================================ 
= 6.0b18 6-3-95 
================================================================================ 
¥ Added docs for the new preferences routines ('addDef', 'addArrDef', 
  'removeDef', and 'removeArrDef', fixed some problems, added 
  a menu item to open up the new alpharc.tcl file, addUserLine now writes 
  to alpharc instead of userStartup.
¥ Slightly re-organized the Filesets menu.
¥ 'menu' now takes a "mode" flag.

================================================================================ 
= 6.0b17 6-3-95 
================================================================================ 
¥ Added new user preferences system, use addDef/removeDef and 
  addArrDef/removeArrDef pairs. In prefs.tcl. 'userStartup.tcl' is no 
  longer sourced! However, there is now a new file called "alpharc.tcl" 
  that is sourced from the prefs folder. No tcl routines add text to
  this file.
¥ Added new "recent files" sub-menu to File menu. "Recent" files can also
  be opened via the 'editFile' dialog.

================================================================================ 
= 6.0b16 6-2-95 
================================================================================ 
¥ cleaned up some messes put in w/ b15


================================================================================ 
= 6.0b15 5-29-95 
================================================================================ 
¥ ordinary deletions after rectangular deletions work better.
¥ PPC scrollbar problem gone
¥ Text buffers now allocated via mac routines vs unix, hopefully giving 
  low memory behavior.

================================================================================ 
= 6.0b14 5-29-95 
================================================================================ 
¥ "Mode:App Paths" a bit easier to use
¥ pathnames longer than 128 chars work
¥ bindings from non-active menus are not active either
¥ some split-pane redrawing problems fixed
¥ 'statusPrompt' no longer appends a space to the prompt
¥ shift no longer works as a binding modifier except for alpha-numerics
¥ command-shift-dash for "Switch to" for compilers now command-shift-s
¥ Nasty bug w/ get_directory and get_file fixed.
¥ All function keys/arrow keys now terminate incremental searches.
¥ 'get_directory' now accepts a prompt argument.
¥ 'statusPrompt' doesn't have problems w/ activate events any more
¥ 'prompt' no longer interprets slashes as command equivalents in menu
¥ command-v now 'paste's from within 'statusPrompt'
¥ 8-bit chars handled better.
¥ Repeat searches now always move at least one char before matching. Let 
  me know what you think.
¥ Some fixes for search-replacements w/ null patterns or replacement 
  strings. '&' in a grep replacement string now works correctly.

================================================================================ 
= 6.0b13 3-25-95 
================================================================================ 
¥ Scrolling vertically through window correctly redraws when obscured by a
  single floating window.
¥ 'addUserLine' now uses curly braces instead of parens.
¥ Cmd-double-clicking now works for "C" tags, Tcl procs in UserCode or 
  SystemCode, and words in the Tcl language. Can also access by selecting 
  a word and using the "Modes:Lookup Name" menu item.
¥ 68k on primitive 68ks better :-)
¥ Bug w/ hiliting on split windows fixed.
¥ Emacs menu can be turned on and off.
¥ Double-clicking on split-window bar toggles split window.

================================================================================ 
= 6.0b12 3-20-95 
================================================================================ 
¥ New price structure, new registration system.
¥ Command-. works again.
¥ 'puts' spits carriage returns again.
¥ better replaceAll behavior
¥ Added '<E' extend style to menu items, forces new dynamic item 
  alternate group. 
¥ Added 'getColors' command.
¥ Added hyperText ability.
¥ 'saveAs' changed.
¥ cmd-double-clicking in the window no longer brings up the mark menu, 
  but clicking on the curly braces and command-clicking on the titlebar both
  still do. cmd-double-clicking now tries to find the definition of a C 
  function (See here).
  
================================================================================ 
= 6.0b11 3-17-95 
================================================================================ 
¥ powerThumb back.
¥ filesets menu now responds to changes in file system if rebuilt. 
  However, this only works for filesets created this by this version or 
  higher. If you want to manually hack your userStartup.tcl to use your 
  old filesets, look at how the 'System' etc. filesets are defined in 
  fileSets.tcl.
¥ AEBuild works for 68k again.
¥ numlock is displayed on the statusbar

================================================================================ 
= 6.0b10 3-15-95 
================================================================================ 
¥ 68k scrollbar thumb, titlebar popup crashes fixed
¥ 'numLock' flag added to remove bindings from keypad and use as keypad. 
  The "clear" or numlock keypad key now toggles this binding.
¥ 'scanfile' (and hence the grep procs) handle unix and ibm files better.

================================================================================ 
= 6.0b9 3-1-95 
================================================================================ 
¥ Alpha correctly creates startup file and directory now.
¥ Keybinding and lookup done differently. Hopefully, the new scheme will 
  allow will better for international users. Please send me mail on 
  whether this is true. Also, handling of the CapsLock key should be much 
  better.
¥ Crashing when dragging thumb gone, but had to temporarily kill 
  powerThumb feature.
¥ Changed 'Csh' mode to 'Shel' mode.
  
================================================================================ 
= 6.0b8 3-1-95 		Switched to CodeWarrior, introduced many problemsÉ
================================================================================ 
¥ INCOMPATIBILITY! "userStartup.tcl" must now be in a "Alpha" folder 
  within your system preferences directory. Alpha will no longer find the 
  old preferences, and WILL NOT copy it over for you.
¥ command-click on window title now give popup menu showing location
¥ cleaner proc now copies instead of moving
¥ isearch doesn't quit when encountering bound characters unless with 
  command, control, or option.
¥ no longer support option modifed US KCHR resource that gets rid of dead 
  keys.
¥ Holding down control (sorry, option unavailable because of rectangular 
  editing) while clicking on paren selects paren in addition to contained 
  expression. 
¥ Toolbox Assistant support added. By default, this has been added to the 
  C, C++, and Pascal modes. YOU MAY NOT SEE THIS IF YOU HAVE ALREADY MODIFIED 
  WHICH MENUS THESE MODES DISPLAY. If this is the case, just use the 
  'setModeMenus' option under the bottom popup menu above the vertical 
  scrollbar.
¥ "Mode:App Paths" allows Alpha's paths to various other applications to
  be viewed, changed, or reset.
¥ Added commands 'splitWindow' and 'otherPane'. Not quite complete.
¥ Added postscript mode.
¥ Several colorizing bugs fixed, most having to do w/ comments.
¥ 'optionIsMeta' gone completely
¥ added 'forceMainScreen' flag. When set, all windows are forced to be 
  completely visible on the main screen. Otherwise, they just stay 
  whereever they open.
¥ 'suppressHeader' phased out in favor of 'printHeader', 
  'printHeaderTime', and 'printHeaderFullPath'.
¥ 'maskCapsLock' is gone, and capslock is handled more intelligently, at 
  least for US keyboards. This *will* be getting better in future versions.
  
================================================================================ 
= 6.0b7 11-14-94 
================================================================================ 
¥ CodeWarrior fixes:
	- create warrior fileset now notices more than one segment
	- timeouts are longer

================================================================================ 
= 6.0b6 11-14-94 
================================================================================ 
¥ Added a few things to support CodeWarrior.
¥ 'edit' now has -w option.


================================================================================ 
= 6.0b4 11-11-94 
================================================================================ 
¥ added 'openTexWindow' to "Latex Utilities" submenu.
¥ fixed bugs in 'newModeVar', 'display'.
¥ slightly changed next/prev(sub)section latex commands to display 
  selected line at top of window
¥ 'userStartup.tcl' moved to "Internal:System Folder:Preferences:Alpha userStartup.tcl"
¥ GNU diff now works for directories other than the startup disk
¥ display bug fixed

================================================================================ 
= 6.0b3 11-11-94 
================================================================================ 
¥ 'replaceText' bug fixed
¥ userStartup cleaner added at quit 
¥ Compare directories is here!
¥ text clippings can now be imported via drag and drop
¥ Now check for drag-n-drop init...

================================================================================ 
= 6.0b2 10-26-94 
================================================================================ 
¥ 'posActivate' gone
¥ Alpha now defines 'screenWidth' and 'screenHeight' variables.
¥ Alpha now checks for windows off screen
¥ Apple drag-n-drop of text and files supported.

================================================================================ 
= 5.98 10-26-94 
================================================================================ 
¥ Fancy new menus!
¥ added Pascal mode. By default, this only recognizes files with .p suffixes.
¥ '-s' search option now saves 	'forward', 'regExpr', 'matchWords', and 
  'ignoreCase'. 
¥ menus now dynamically sourced.
¥ if '&' last char in menu item, no special chars interpreted.
¥ 'regModeKeywords' now allows additional keywords to be added, possible 
  of a different color than older keywords.
¥ 'largestPrefix' returns largest common prefix of a list of strings.
¥ 'getNamedMarks' changed behavior.
¥ 'regModeKeywords' has been changed.
¥ "File:Win Sets" submenu.
¥ Assorted color improvements.
¥ 'listpick' now returns an error if "Cancel" is selected.
¥ double-clicking on parens, square brackets, and curly brances selects 
  entire expression.
  
================================================================================ 
= 5.97 9-26-94 
================================================================================ 
¥ ReplaceAll now notices and complains about regular expressions that 
  match zero-length pieces of text.
¥ Included GNU Diff w/ distribution. I forgot it w/ the previous two 
  distributions. 
  
================================================================================ 
= 5.96 9-25-94 
================================================================================ 
